"""Autogenerated API schema"""
from argus_api import session


add_host_application = {'tags': ['assets/v1'], 'summary': 'Creates a new HostApplication. (PUBLIC)', 'description': '', 'operationId': 'addHostApplication', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'HostApplication add request', 'required': False, 'schema': {'type': 'object', 'required': ['hostID', 'sockets', 'source'], 'properties': {'hostID': {'type': 'str', 'position': 0, 'description': 'Specify parent host.'}, 'roleID': {'type': 'int', 'position': 0, 'description': 'Specify application role.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of application. => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Description of application. => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Custom user-defined properties. => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'source': {'type': 'str', 'position': 0, 'description': 'Source of the request. (default USER)', 'enum': ['USER', 'CVM']}, 'cpe': {'type': 'str', 'position': 0, 'description': 'CPE of application.'}, 'sockets': {'type': 'list', 'position': 0, 'description': 'Specify socket strings of the application.', 'uniqueItems': True, 'items': {'type': 'string'}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset'}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
delete_host_application = {'tags': ['assets/v1'], 'summary': 'Marks a HostApplication as deleted. (PUBLIC)', 'description': '', 'operationId': 'deleteHostApplication', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'HostApplication ID', 'required': True, 'type': 'str'}, {'name': 'source', 'in': 'query', 'description': 'Request source (default USER)', 'required': False, 'type': 'str', 'default': 'USER', 'enum': ['USER', 'CVM']}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset'}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
get_host_application = {'tags': ['assets/v1'], 'summary': 'Returns a HostApplication identified by its ID. (PUBLIC)', 'description': '', 'operationId': 'getHostApplication', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'HostApplication ID', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset'}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
search_host_application_statistics = {'tags': ['assets/v1'], 'summary': 'Fetch host application statistics base on criteria (PUBLIC)', 'description': '', 'operationId': 'searchHostApplicationStatistics', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Statistics search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': []}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'startTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Search for applications by role (list of role IDs).', 'uniqueItems': True, 'items': {'type': 'int'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'cpe', 'hostName', 'hostAlias', 'all']}}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['name', 'cpe', 'role', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', '-name', '-cpe', '-role', '-createdTimestamp', '-lastUpdatedTimestamp', '-lastEventTimestamp', '-deletedTimestamp', '-firstSeenTimestamp', '-lastSeenTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'startTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Search for applications by role (list of role IDs).', 'uniqueItems': True, 'items': {'type': 'int'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'cpe', 'hostName', 'hostAlias', 'all']}}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['name', 'cpe', 'role', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', '-name', '-cpe', '-role', '-createdTimestamp', '-lastUpdatedTimestamp', '-lastEventTimestamp', '-deletedTimestamp', '-firstSeenTimestamp', '-lastSeenTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'startTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Search for applications by role (list of role IDs).', 'uniqueItems': True, 'items': {'type': 'int'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'cpe', 'hostName', 'hostAlias', 'all']}}, 'groupBy': {'type': 'list', 'position': 0, 'description': 'Specify which fields will be grouped by in stats', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['customer', 'host', 'service', 'businessProcess', 'applicationVendor', 'applicationName', 'applicationVersion', 'protocol', 'port']}}, 'values': {'type': 'list', 'position': 0, 'description': 'Specify which values will be included in stats (default applications)', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['applications', 'scannedApplications', 'missedApplications']}, 'maxItems': 2147483647, 'minItems': 1}, 'resolution': {'type': 'int', 'position': 0, 'description': 'Stats resolution period in milliseconds, if is 0 means to generate non-timeline statistics', 'minimum': 0}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Reduce stats keys to the cutoff amount of keys that has largest hit count, default 0 means no reduce', 'minimum': 0}, 'cutoffValue': {'type': 'str', 'position': 0, 'description': 'Specify which value to be cutoff on (default applications)', 'enum': ['applications', 'scannedApplications', 'missedApplications']}, 'includeOthers': {'type': 'bool', 'position': 0, 'description': 'If reduce (cutoff >0), true means remaining keys (other than cutoff keys) are collected into an "other" key, default false'}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['name', 'cpe', 'role', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', '-name', '-cpe', '-role', '-createdTimestamp', '-lastUpdatedTimestamp', '-lastEventTimestamp', '-deletedTimestamp', '-firstSeenTimestamp', '-lastSeenTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'statsID': {'type': 'int', 'position': 0, 'description': 'Statistics ID'}, 'customerID': {'type': 'int', 'position': 0, 'description': 'Customer ID'}, 'resolution': {'type': 'int', 'position': 0, 'description': 'Statistics time frame period length'}, 'resolutionUnit': {'type': 'str', 'position': 0, 'description': 'Time unit for the resolution', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days', 'weeks', 'months', 'years']}, 'records': {'type': 'int', 'position': 0, 'description': 'Amount of records'}, 'hitCount': {'type': 'dict', 'position': 0, 'description': 'Total amount of hits per value', 'additionalProperties': {'type': 'int'}}, 'keyNames': {'type': 'list', 'position': 0, 'description': 'List of key names', 'items': {'type': 'string'}}, 'valueNames': {'type': 'list', 'position': 0, 'description': 'List of value names', 'items': {'type': 'string'}}, 'keys': {'type': 'list', 'position': 0, 'description': 'List of statistics keys e.g. {"id":1, "key1Name":"key1", "key2Name":"key2"}', 'items': {'type': 'dict', 'additionalProperties': {'type': 'object'}}}, 'timeFrames': {'type': 'list', 'position': 0, 'description': 'List of statistics records grouped by time frame', 'items': {'type': 'dict', 'properties': {'records': {'type': 'list', 'items': {'type': 'dict', 'properties': {'keyID': {'type': 'int'}, 'value': {'type': 'dict', 'additionalProperties': {'type': 'int'}}}}}, 'timeFrame': {'type': 'dict', 'properties': {'startTime': {'type': 'int'}, 'endTime': {'type': 'int'}}}}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}
search_host_applications = {'tags': ['assets/v1'], 'summary': 'Returns a set of HostApplications defined by a HostApplicationSearchCriteria. (PUBLIC)', 'description': '', 'operationId': 'searchHostApplications', 'consumes': ['application/json'], 'produces': ['application/json', 'text/csv'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.'}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects.'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR.', 'uniqueItems': True, 'items': []}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'startTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Search for applications by role (list of role IDs).', 'uniqueItems': True, 'items': {'type': 'int'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'cpe', 'hostName', 'hostAlias', 'all']}}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['name', 'cpe', 'role', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', '-name', '-cpe', '-role', '-createdTimestamp', '-lastUpdatedTimestamp', '-lastEventTimestamp', '-deletedTimestamp', '-firstSeenTimestamp', '-lastSeenTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'startTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'str', 'position': 0, 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Search for applications by role (list of role IDs).', 'uniqueItems': True, 'items': {'type': 'int'}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields).', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'cpe', 'hostName', 'hostAlias', 'all']}}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending).', 'items': {'type': 'str', 'enum': ['name', 'cpe', 'role', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', '-name', '-cpe', '-role', '-createdTimestamp', '-lastUpdatedTimestamp', '-lastEventTimestamp', '-deletedTimestamp', '-firstSeenTimestamp', '-lastSeenTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset'}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
search_host_applications_simplified = {'tags': ['assets/v1'], 'summary': 'Returns a set of HostApplications defined by query parameters. (PUBLIC)', 'description': '', 'operationId': 'searchHostApplicationsSimplified', 'produces': ['application/json', 'text/csv'], 'parameters': [{'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'required': False, 'type': 'int', 'default': 25, 'minimum': 0}, {'name': 'keywords', 'in': 'query', 'description': 'Search by keywords', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'keywordMatch', 'in': 'query', 'description': 'Set match strategy for keyword search', 'required': False, 'type': 'str', 'default': 'all', 'enum': ['all', 'any']}, {'name': 'keywordField', 'in': 'query', 'description': 'Set field strategy for keyword search', 'required': False, 'type': 'list', 'items': {'type': 'str', 'default': 'all', 'enum': ['name', 'description', 'cpe', 'hostName', 'hostAlias', 'all']}, 'collectionFormat': 'multi'}, {'name': 'name', 'in': 'query', 'description': 'Search by name', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'hostID', 'in': 'query', 'description': 'Search by HostAsset ID', 'required': False, 'type': 'list', 'items': {'type': 'str'}, 'collectionFormat': 'multi'}, {'name': 'serviceID', 'in': 'query', 'description': 'Search by ServiceAsset ID', 'required': False, 'type': 'list', 'items': {'type': 'str'}, 'collectionFormat': 'multi'}, {'name': 'businessProcessID', 'in': 'query', 'description': 'Search by BusinessProcess ID', 'required': False, 'type': 'list', 'items': {'type': 'str'}, 'collectionFormat': 'multi'}, {'name': 'customerID', 'in': 'query', 'description': 'Search by customer ID', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'ip', 'in': 'query', 'description': 'Search by IP range', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'port', 'in': 'query', 'description': 'Search by application port', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'protocol', 'in': 'query', 'description': 'Search by application protocol', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}, 'collectionFormat': 'multi'}, {'name': 'cpe', 'in': 'query', 'description': 'Search by CPE', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'includeFlag', 'in': 'query', 'description': 'Include certain HostApplications in the search result based on set flags', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}, 'collectionFormat': 'multi'}, {'name': 'excludeFlag', 'in': 'query', 'description': 'Exclude certain HostApplications from the search result based on set flags', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}, 'collectionFormat': 'multi'}, {'name': 'sortBy', 'in': 'query', 'description': 'Sort search result', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'countTimeout', 'in': 'query', 'description': 'Max wait in seconds for count query. Value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'required': False, 'type': 'int', 'maximum': 30, 'minimum': -1}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset'}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
update_host_application = {'tags': ['assets/v1'], 'summary': 'Updates an existing HostApplication. (PUBLIC)', 'description': '', 'operationId': 'updateHostApplication', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'HostApplication ID', 'required': True, 'type': 'str'}, {'in': 'body', 'name': 'body', 'description': 'HostApplication update request', 'required': False, 'schema': {'type': 'object', 'required': ['source'], 'properties': {'roleID': {'type': 'int', 'position': 0, 'description': 'Change application role.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Change application name. => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Change application description. => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'addProperties': {'type': 'dict', 'position': 0, 'description': 'Add properties to application (updates a property if key already exists). => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'deleteProperties': {'type': 'list', 'position': 0, 'description': 'Remove properties from application by key.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'source': {'type': 'str', 'position': 0, 'description': 'Source of the request. (default USER)', 'enum': ['USER', 'CVM']}, 'cpe': {'type': 'str', 'position': 0, 'description': 'Change application CPE.'}, 'addSockets': {'type': 'list', 'position': 0, 'description': 'Add sockets to application (list of protocol/port, e.g. tcp/80).', 'uniqueItems': True, 'items': {'type': 'string'}}, 'deleteSockets': {'type': 'list', 'position': 0, 'description': 'Remove sockets from application (list of protocol/port, e.g. tcp/80).', 'uniqueItems': True, 'items': {'type': 'string'}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset'}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}}}, '220': {'description': 'No value to be updated', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': {'type': 'string', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'integer', 'format': 'int64'}}}}, 'data': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'host': {'type': 'object', 'required': ['name'], 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'position': 0, 'description': 'The authorative name of the asset'}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64'}, 'createdByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'position': 0, 'description': 'Type of the subject', 'readOnly': True, 'enum': ['user', 'group']}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'position': 0, 'description': 'Type of the subject', 'readOnly': True, 'enum': ['user', 'group']}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64'}, 'deletedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}, 'type': {'type': 'string', 'position': 0, 'description': 'Type of the subject', 'readOnly': True, 'enum': ['user', 'group']}}}, 'firstSeenTimestamp': {'type': 'integer', 'format': 'int64'}, 'lastSeenTimestamp': {'type': 'integer', 'format': 'int64'}, 'properties': {'type': 'object', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'string', 'readOnly': True}, 'sockets': {'type': 'array', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'array', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'string', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}