"""Autogenerated API schema"""
from argus_api import session


list_default_watchers = {'tags': ['cases/v2/case'], 'summary': 'List default watchers for a specified service (PUBLIC)', 'description': '', 'operationId': 'listDefaultWatchers', 'produces': ['application/json'], 'parameters': [{'name': 'offset', 'in': 'query', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'required': False, 'type': 'int', 'default': 25, 'minimum': 0}, {'name': 'customer', 'in': 'query', 'description': 'Filter watchers by customer', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'service', 'in': 'query', 'description': 'Filter watchers by service', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'caseType', 'in': 'query', 'description': 'Filter watchers by caseType', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}, 'collectionFormat': 'multi'}, {'name': 'priority', 'in': 'query', 'description': 'Filter watchers by priority', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'collectionFormat': 'multi'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'required': ['caseType', 'customer', 'priority', 'service', 'watcherType'], 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'Contact ID of this default watcher'}, 'watcherType': {'type': 'str', 'position': 0, 'description': 'Type of this watcher (user or mailbox)', 'enum': ['subject', 'mailbox']}, 'subject': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'shortName': {'type': 'str', 'position': 0, 'description': "The subject's short name"}, 'name': {'type': 'str', 'position': 0, 'description': "The subject's name"}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the domain.'}}, 'description': 'SPI DomainInfo'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the customer.'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'Shortname of the customer.'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the domain.'}}, 'description': 'SPI DomainInfo'}}, 'description': 'SPI CustomerInfo'}, 'type': 'str', 'options': ['user', 'group']}, 'description': 'SPI SubjectInfo'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the customer.'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'Shortname of the customer.'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the domain.'}}, 'description': 'SPI DomainInfo'}}, 'description': 'SPI CustomerInfo'}, 'service': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'str', 'position': 0, 'description': 'Service name', 'readOnly': True}, 'shortName': {'type': 'str', 'position': 0, 'description': 'Service shortname', 'readOnly': True}, 'localizedName': {'type': 'str', 'position': 0, 'description': 'Service name localized to the current users language', 'readOnly': True}}}, 'mailbox': {'type': 'dict', 'properties': {'email': {'type': 'string'}, 'name': {'type': 'string'}}, 'description': 'Describes a mailbox for a mailbox type watcher'}, 'priority': {'type': 'list', 'position': 0, 'description': 'The case priorities this watcher is active for', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}, 'caseType': {'type': 'list', 'position': 0, 'description': 'The case types this watcher is active for', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['securityIncident', 'operationalIncident', 'informational', 'change']}}}, 'description': 'Models a default watcher configuration (currently wrapped from Customer Contacts)'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}