"""Autogenerated API schema"""
from argus_api import session


get_property = {'tags': ['componentadmin/v1'], 'summary': 'Fetch property from runtime components (INTERNAL)', 'description': '', 'operationId': 'getProperty', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'property', 'in': 'path', 'description': 'Property to fetch', 'required': True, 'type': 'str'}, {'in': 'body', 'name': 'body', 'description': 'Property fetch request', 'required': False, 'schema': {'type': 'object', 'properties': {'pattern': {'type': 'dict', 'properties': {'exact': {'type': 'boolean'}, 'identifiers': {'type': 'dict', 'additionalProperties': {'type': 'string'}}}}, 'type': {'type': 'string'}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'identity': {'type': 'dict', 'properties': {'exact': {'type': 'boolean'}, 'identifiers': {'type': 'dict', 'additionalProperties': {'type': 'string'}}}}, 'value': {'type': 'dict', 'position': 0, 'description': 'The value of the property for this component'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '409': {'description': 'Remote invocation failed'}}}
#: "get_properties_1" is an alias for "get_property"
get_properties_1 = get_property