"""Autogenerated API schema"""
from argus_api import session


find_aggregated_event_stats = {'tags': ['events/v1'], 'summary': 'Fetch aggregated event stats (PUBLIC)', 'description': 'Returns a StatsContainer JSON format.', 'operationId': 'findAggregatedEventStats', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'required': False, 'schema': {'type': 'object', 'properties': {'signature': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourceIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'ip': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationPort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourcePort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'port': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'minSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'maxSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented)'}, 'customerID': {'type': 'list', 'xml': {'name': 'Customers', 'wrapped': True}, 'position': 0, 'description': 'DEPRECATED! Use customer instead', 'uniqueItems': True, 'items': {'type': 'int', 'xml': {'name': 'CustomerID'}}}, 'skipFutureEvents': {'type': 'bool', 'position': 0, 'description': 'Whether service should generate endTimestamp by current timestamp. (default false)', 'default': False}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Exclude these criteria from the parent criteria.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'eventIdentifier': {'type': 'list', 'position': 0, 'description': 'Search for events specified by full ID (type/timestamp/customerid/eventid).', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'type': 'str', 'timestamp': {'type': 'int', 'xml': {'attribute': True}}, 'customerID': {'type': 'int', 'xml': {'attribute': True}}, 'eventID': {'type': 'str', 'xml': {'attribute': True}}}}}, 'locationID': {'type': 'list', 'position': 0, 'description': 'Search for events having these locations.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'severity': {'type': 'list', 'position': 0, 'description': "Search events with specified severity. Can't be used together with minSeverity/maxSeverity.", 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}, 'customer': {'type': 'list', 'position': 0, 'description': 'Search for events by customer (id or shortname).', 'uniqueItems': True, 'items': {'type': 'string'}}, 'alarmID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these alarms.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'attackCategoryID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these categories.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'geoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source or destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'domain': {'type': 'list', 'position': 0, 'description': 'Search for events having one of these domains. The domains are not validated', 'uniqueItems': True, 'items': {'type': 'string'}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Search for events having these properties (logical AND).', 'additionalProperties': {'type': 'string'}}, 'productionCustomers': {'type': 'bool', 'position': 0, 'description': "If set, apply a customer filter for customers marked as 'not in production'. If true, EXCLUDE customers 'not in production'. If false, REQUIRE customers 'not in production'. Default is unset (no filter on production customers)."}, 'exactMatchProperties': {'type': 'bool', 'position': 0, 'description': 'If set to true, will execute in-memory filtering to only match events that have exact match of properties specified at top level "properties" field of search request. WARN: The count of response would not be reliable, as the filtering is applied in-memory of application server, but the count was done by search engine. (default true)', 'default': True}, 'minCount': {'type': 'int', 'position': 0, 'description': 'Search for events with aggregated count at least this high'}, 'associatedCaseID': {'type': 'list', 'position': 0, 'description': 'Search for events associated to one of these cases, 0 will match events NOT associated with any case', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include source CIDR-networks with wider mask than this'}, 'destinationIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include destination CIDR-networks with wider mask than this'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Allow subcriteria (include or exclude), to refine search arbitrarily', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'signature': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourceIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'ip': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationPort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourcePort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'port': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'minSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'maxSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'limit': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Limit results'}, 'offset': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Offset results'}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented)'}, 'customerID': {'type': 'list', 'xml': {'name': 'Customers', 'wrapped': True}, 'position': 0, 'description': 'DEPRECATED! Use customer instead', 'uniqueItems': True, 'items': {'type': 'int', 'xml': {'name': 'CustomerID'}}}, 'skipFutureEvents': {'type': 'bool', 'position': 0, 'description': 'Whether service should generate endTimestamp by current timestamp. (default false)', 'default': False}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Exclude these criteria from the parent criteria.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'eventIdentifier': {'type': 'list', 'position': 0, 'description': 'Search for events specified by full ID (type/timestamp/customerid/eventid).', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'type': 'str', 'timestamp': {'type': 'int', 'xml': {'attribute': True}}, 'customerID': {'type': 'int', 'xml': {'attribute': True}}, 'eventID': {'type': 'str', 'xml': {'attribute': True}}}}}, 'locationID': {'type': 'list', 'position': 0, 'description': 'Search for events having these locations.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'severity': {'type': 'list', 'position': 0, 'description': "Search events with specified severity. Can't be used together with minSeverity/maxSeverity.", 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}, 'customer': {'type': 'list', 'position': 0, 'description': 'Search for events by customer (id or shortname).', 'uniqueItems': True, 'items': {'type': 'string'}}, 'alarmID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these alarms.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'attackCategoryID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these categories.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'geoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source or destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'domain': {'type': 'list', 'position': 0, 'description': 'Search for events having one of these domains. The domains are not validated', 'uniqueItems': True, 'items': {'type': 'string'}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Search for events having these properties (logical AND).', 'additionalProperties': {'type': 'string'}}, 'productionCustomers': {'type': 'bool', 'position': 0, 'description': "If set, apply a customer filter for customers marked as 'not in production'. If true, EXCLUDE customers 'not in production'. If false, REQUIRE customers 'not in production'. Default is unset (no filter on production customers)."}, 'exactMatchProperties': {'type': 'bool', 'position': 0, 'description': 'If set to true, will execute in-memory filtering to only match events that have exact match of properties specified at top level "properties" field of search request. WARN: The count of response would not be reliable, as the filtering is applied in-memory of application server, but the count was done by search engine. (default true)', 'default': True}, 'minCount': {'type': 'int', 'position': 0, 'description': 'Search for events with aggregated count at least this high'}, 'associatedCaseID': {'type': 'list', 'position': 0, 'description': 'Search for events associated to one of these cases, 0 will match events NOT associated with any case', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include source CIDR-networks with wider mask than this'}, 'destinationIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include destination CIDR-networks with wider mask than this'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Allow subcriteria (include or exclude), to refine search arbitrarily', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'signature': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourceIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'ip': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationPort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourcePort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'port': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'minSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'maxSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'limit': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Limit results'}, 'offset': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Offset results'}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented)'}, 'customerID': {'type': 'list', 'xml': {'name': 'Customers', 'wrapped': True}, 'position': 0, 'description': 'DEPRECATED! Use customer instead', 'uniqueItems': True, 'items': {'type': 'int', 'xml': {'name': 'CustomerID'}}}, 'skipFutureEvents': {'type': 'bool', 'position': 0, 'description': 'Whether service should generate endTimestamp by current timestamp. (default false)', 'default': False}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Exclude these criteria from the parent criteria.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'eventIdentifier': {'type': 'list', 'position': 0, 'description': 'Search for events specified by full ID (type/timestamp/customerid/eventid).', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'type': 'str', 'timestamp': {'type': 'int', 'xml': {'attribute': True}}, 'customerID': {'type': 'int', 'xml': {'attribute': True}}, 'eventID': {'type': 'str', 'xml': {'attribute': True}}}}}, 'locationID': {'type': 'list', 'position': 0, 'description': 'Search for events having these locations.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'severity': {'type': 'list', 'position': 0, 'description': "Search events with specified severity. Can't be used together with minSeverity/maxSeverity.", 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}, 'customer': {'type': 'list', 'position': 0, 'description': 'Search for events by customer (id or shortname).', 'uniqueItems': True, 'items': {'type': 'string'}}, 'alarmID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these alarms.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'attackCategoryID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these categories.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'geoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source or destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'domain': {'type': 'list', 'position': 0, 'description': 'Search for events having one of these domains. The domains are not validated', 'uniqueItems': True, 'items': {'type': 'string'}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Search for events having these properties (logical AND).', 'additionalProperties': {'type': 'string'}}, 'productionCustomers': {'type': 'bool', 'position': 0, 'description': "If set, apply a customer filter for customers marked as 'not in production'. If true, EXCLUDE customers 'not in production'. If false, REQUIRE customers 'not in production'. Default is unset (no filter on production customers)."}, 'exactMatchProperties': {'type': 'bool', 'position': 0, 'description': 'If set to true, will execute in-memory filtering to only match events that have exact match of properties specified at top level "properties" field of search request. WARN: The count of response would not be reliable, as the filtering is applied in-memory of application server, but the count was done by search engine. (default true)', 'default': True}, 'minCount': {'type': 'int', 'position': 0, 'description': 'Search for events with aggregated count at least this high'}, 'associatedCaseID': {'type': 'list', 'position': 0, 'description': 'Search for events associated to one of these cases, 0 will match events NOT associated with any case', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include source CIDR-networks with wider mask than this'}, 'destinationIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include destination CIDR-networks with wider mask than this'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Allow subcriteria (include or exclude), to refine search arbitrarily', 'uniqueItems': True, 'items': []}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search, will default to startTimestamp/endTimestamp.This field cannot be used alongside the lastUpdateTime field due to backwards compatibility.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['timestamp', 'startTimestamp', 'endTimestamp', 'all']}}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp'}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp'}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'Order results by these properties (prefix with - to sort descending)', 'items': {'type': 'string'}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Search objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Match only with events marked with a last updated time greater or equal to this.'}, 'indexStartTime': {'type': 'int', 'position': 0, 'description': 'Earliest created time of the indices searched.', 'minimum': 0}, 'indexEndTime': {'type': 'int', 'position': 0, 'description': 'Last created time of the indices searched.', 'minimum': 0}}}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search, will default to startTimestamp/endTimestamp.This field cannot be used alongside the lastUpdateTime field due to backwards compatibility.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['timestamp', 'startTimestamp', 'endTimestamp', 'all']}}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp'}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp'}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'Order results by these properties (prefix with - to sort descending)', 'items': {'type': 'string'}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Search objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Match only with events marked with a last updated time greater or equal to this.'}, 'indexStartTime': {'type': 'int', 'position': 0, 'description': 'Earliest created time of the indices searched.', 'minimum': 0}, 'indexEndTime': {'type': 'int', 'position': 0, 'description': 'Last created time of the indices searched.', 'minimum': 0}}}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search, will default to startTimestamp/endTimestamp.This field cannot be used alongside the lastUpdateTime field due to backwards compatibility.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['timestamp', 'startTimestamp', 'endTimestamp', 'all']}}, 'resolution': {'type': 'int', 'position': 0, 'description': 'Divide results into timeframes with this size (in milliseconds)', 'minimum': 0}, 'resolutionUnit': {'type': 'str', 'position': 0, 'description': 'For use with date histogram, this will bind the intervals to the unit given.Calendar units, such as weeks, months, and years, can only be used with a resolution of 1. Default is milliseconds', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days', 'weeks', 'months', 'years']}, 'groupBy': {'type': 'list', 'position': 0, 'description': 'Group results by these fields', 'items': {'type': 'str', 'enum': ['ATTACK_IDENTIFIER', 'ATTACK_CATEGORY', 'ALARM', 'LOCATION', 'EVENT_SEVERITY', 'SOURCEIP', 'DESTINATIONIP', 'PROTOCOL', 'CUSTOMER', 'SOURCE_GEOIP_LOCATION', 'SOURCE_GEOIP_COUNTRY', 'DESTINATION_GEOIP_LOCATION', 'DESTINATION_GEOIP_COUNTRY']}}, 'countRawEvents': {'type': 'bool', 'position': 0, 'description': 'Return the number of raw events (not the number of aggregated events)'}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'If set, keep the <cutoff> biggest records, and cut off the rest.', 'minimum': 0}, 'includeOthers': {'type': 'bool', 'position': 0, 'description': 'If true (default), records which are cut off are collected into a common "other" record'}, 'timeFrameStrategy': {'type': 'str', 'position': 0, 'description': 'Configures the aggregation search to use start/end timestamp or just event timestamp for the timeframe of the search. (default startEndTimestamp)', 'enum': ['timestamp', 'startEndTimestamp']}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp'}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp'}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Search objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Match only with events marked with a last updated time greater or equal to this.'}, 'indexStartTime': {'type': 'int', 'position': 0, 'description': 'Earliest created time of the indices searched.', 'minimum': 0}, 'indexEndTime': {'type': 'int', 'position': 0, 'description': 'Last created time of the indices searched.', 'minimum': 0}}}}], 'responses': {'401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}
find_aggregated_events = {'tags': ['events/v1'], 'summary': 'Search for aggregated events (PUBLIC)', 'description': '', 'operationId': 'findAggregatedEvents', 'consumes': ['application/json'], 'produces': ['application/json', 'text/csv'], 'parameters': [{'name': 'Accept', 'in': 'header', 'required': False, 'type': 'string'}, {'in': 'body', 'name': 'body', 'description': 'Search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'signature': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourceIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'ip': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationPort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourcePort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'port': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'minSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'maxSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'limit': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Limit results'}, 'offset': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Offset results'}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented)'}, 'customerID': {'type': 'list', 'xml': {'name': 'Customers', 'wrapped': True}, 'position': 0, 'description': 'DEPRECATED! Use customer instead', 'uniqueItems': True, 'items': {'type': 'int', 'xml': {'name': 'CustomerID'}}}, 'skipFutureEvents': {'type': 'bool', 'position': 0, 'description': 'Whether service should generate endTimestamp by current timestamp. (default false)', 'default': False}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Exclude these criteria from the parent criteria.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'eventIdentifier': {'type': 'list', 'position': 0, 'description': 'Search for events specified by full ID (type/timestamp/customerid/eventid).', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'type': 'str', 'timestamp': {'type': 'int', 'xml': {'attribute': True}}, 'customerID': {'type': 'int', 'xml': {'attribute': True}}, 'eventID': {'type': 'str', 'xml': {'attribute': True}}}}}, 'locationID': {'type': 'list', 'position': 0, 'description': 'Search for events having these locations.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'severity': {'type': 'list', 'position': 0, 'description': "Search events with specified severity. Can't be used together with minSeverity/maxSeverity.", 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}, 'customer': {'type': 'list', 'position': 0, 'description': 'Search for events by customer (id or shortname).', 'uniqueItems': True, 'items': {'type': 'string'}}, 'alarmID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these alarms.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'attackCategoryID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these categories.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'geoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source or destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'domain': {'type': 'list', 'position': 0, 'description': 'Search for events having one of these domains. The domains are not validated', 'uniqueItems': True, 'items': {'type': 'string'}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Search for events having these properties (logical AND).', 'additionalProperties': {'type': 'string'}}, 'productionCustomers': {'type': 'bool', 'position': 0, 'description': "If set, apply a customer filter for customers marked as 'not in production'. If true, EXCLUDE customers 'not in production'. If false, REQUIRE customers 'not in production'. Default is unset (no filter on production customers)."}, 'exactMatchProperties': {'type': 'bool', 'position': 0, 'description': 'If set to true, will execute in-memory filtering to only match events that have exact match of properties specified at top level "properties" field of search request. WARN: The count of response would not be reliable, as the filtering is applied in-memory of application server, but the count was done by search engine. (default true)', 'default': True}, 'minCount': {'type': 'int', 'position': 0, 'description': 'Search for events with aggregated count at least this high'}, 'associatedCaseID': {'type': 'list', 'position': 0, 'description': 'Search for events associated to one of these cases, 0 will match events NOT associated with any case', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include source CIDR-networks with wider mask than this'}, 'destinationIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include destination CIDR-networks with wider mask than this'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Allow subcriteria (include or exclude), to refine search arbitrarily', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'signature': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourceIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'ip': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationPort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourcePort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'port': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'minSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'maxSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'limit': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Limit results'}, 'offset': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Offset results'}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented)'}, 'customerID': {'type': 'list', 'xml': {'name': 'Customers', 'wrapped': True}, 'position': 0, 'description': 'DEPRECATED! Use customer instead', 'uniqueItems': True, 'items': {'type': 'int', 'xml': {'name': 'CustomerID'}}}, 'skipFutureEvents': {'type': 'bool', 'position': 0, 'description': 'Whether service should generate endTimestamp by current timestamp. (default false)', 'default': False}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Exclude these criteria from the parent criteria.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'eventIdentifier': {'type': 'list', 'position': 0, 'description': 'Search for events specified by full ID (type/timestamp/customerid/eventid).', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'type': 'str', 'timestamp': {'type': 'int', 'xml': {'attribute': True}}, 'customerID': {'type': 'int', 'xml': {'attribute': True}}, 'eventID': {'type': 'str', 'xml': {'attribute': True}}}}}, 'locationID': {'type': 'list', 'position': 0, 'description': 'Search for events having these locations.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'severity': {'type': 'list', 'position': 0, 'description': "Search events with specified severity. Can't be used together with minSeverity/maxSeverity.", 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}, 'customer': {'type': 'list', 'position': 0, 'description': 'Search for events by customer (id or shortname).', 'uniqueItems': True, 'items': {'type': 'string'}}, 'alarmID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these alarms.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'attackCategoryID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these categories.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'geoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source or destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'domain': {'type': 'list', 'position': 0, 'description': 'Search for events having one of these domains. The domains are not validated', 'uniqueItems': True, 'items': {'type': 'string'}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Search for events having these properties (logical AND).', 'additionalProperties': {'type': 'string'}}, 'productionCustomers': {'type': 'bool', 'position': 0, 'description': "If set, apply a customer filter for customers marked as 'not in production'. If true, EXCLUDE customers 'not in production'. If false, REQUIRE customers 'not in production'. Default is unset (no filter on production customers)."}, 'exactMatchProperties': {'type': 'bool', 'position': 0, 'description': 'If set to true, will execute in-memory filtering to only match events that have exact match of properties specified at top level "properties" field of search request. WARN: The count of response would not be reliable, as the filtering is applied in-memory of application server, but the count was done by search engine. (default true)', 'default': True}, 'minCount': {'type': 'int', 'position': 0, 'description': 'Search for events with aggregated count at least this high'}, 'associatedCaseID': {'type': 'list', 'position': 0, 'description': 'Search for events associated to one of these cases, 0 will match events NOT associated with any case', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include source CIDR-networks with wider mask than this'}, 'destinationIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include destination CIDR-networks with wider mask than this'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Allow subcriteria (include or exclude), to refine search arbitrarily', 'uniqueItems': True, 'items': []}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search, will default to startTimestamp/endTimestamp.This field cannot be used alongside the lastUpdateTime field due to backwards compatibility.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['timestamp', 'startTimestamp', 'endTimestamp', 'all']}}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp'}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp'}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'Order results by these properties (prefix with - to sort descending)', 'items': {'type': 'string'}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Search objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Match only with events marked with a last updated time greater or equal to this.'}, 'indexStartTime': {'type': 'int', 'position': 0, 'description': 'Earliest created time of the indices searched.', 'minimum': 0}, 'indexEndTime': {'type': 'int', 'position': 0, 'description': 'Last created time of the indices searched.', 'minimum': 0}}}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search, will default to startTimestamp/endTimestamp.This field cannot be used alongside the lastUpdateTime field due to backwards compatibility.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['timestamp', 'startTimestamp', 'endTimestamp', 'all']}}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp'}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp'}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'Order results by these properties (prefix with - to sort descending)', 'items': {'type': 'string'}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Search objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Match only with events marked with a last updated time greater or equal to this.'}, 'indexStartTime': {'type': 'int', 'position': 0, 'description': 'Earliest created time of the indices searched.', 'minimum': 0}, 'indexEndTime': {'type': 'int', 'position': 0, 'description': 'Last created time of the indices searched.', 'minimum': 0}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'associatedCase': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'subject': {'type': 'string'}, 'categoryID': {'type': 'int'}, 'categoryName': {'type': 'string'}, 'service': {'type': 'string'}, 'status': {'type': 'str', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'priority': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}}, 'protocol': {'type': 'string'}, 'flags': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'severity': {'type': 'str', 'readOnly': True, 'enum': ['low', 'medium', 'high', 'critical']}, 'detailedEventIDS': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'id': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}, 'customerInfo': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'shortName': {'type': 'string'}, 'name': {'type': 'string'}}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Dynamic list of properties related to the event', 'additionalProperties': {'type': 'string'}}, 'comments': {'type': 'list', 'position': 0, 'description': 'User, or agent, generated comments for the event', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'associatedCases': {'type': 'list', 'position': 0, 'description': 'Case information for the cases associated to the event.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'subject': {'type': 'string'}, 'categoryID': {'type': 'int'}, 'categoryName': {'type': 'string'}, 'service': {'type': 'string'}, 'status': {'type': 'str', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'priority': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}}}, 'location': {'type': 'dict', 'properties': {'shortName': {'type': 'string'}, 'name': {'type': 'string'}, 'timeZone': {'type': 'string'}, 'id': {'type': 'int'}}}, 'attackInfo': {'type': 'dict', 'properties': {'alarmID': {'type': 'int'}, 'alarmDescription': {'type': 'string'}, 'attackCategoryID': {'type': 'int'}, 'attackCategoryName': {'type': 'string'}, 'signature': {'type': 'string'}}}, 'domain': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'uri': {'type': 'str', 'position': 0, 'description': 'URI of the event'}, 'count': {'type': 'int', 'position': 0, 'description': 'Number of observations for this aggregate'}, 'source': {'type': 'dict', 'properties': {'port': {'type': 'int'}, 'geoLocation': {'type': 'dict', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'locationName': {'type': 'string'}, 'latitude': {'type': 'float'}, 'longitude': {'type': 'float'}}}, 'networkAddress': {'type': 'dict', 'properties': {'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'multicast': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'destination': {'type': 'dict', 'properties': {'port': {'type': 'int'}, 'geoLocation': {'type': 'dict', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'locationName': {'type': 'string'}, 'latitude': {'type': 'float'}, 'longitude': {'type': 'float'}}}, 'networkAddress': {'type': 'dict', 'properties': {'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'multicast': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'timestamp': {'type': 'int', 'position': 0, 'description': 'The time the event happened.'}, 'startTimestamp': {'type': 'int', 'position': 0, 'description': 'First observed event for this aggregate'}, 'endTimestamp': {'type': 'int', 'position': 0, 'description': 'Last observed event for this aggregate'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Last update for the aggregated event'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}
list_aggregated_events = {'tags': ['events/v1'], 'summary': 'Simple search for aggregated events (PUBLIC)', 'description': '', 'operationId': 'listAggregatedEvents', 'produces': ['application/json', 'text/csv'], 'parameters': [{'name': 'Accept', 'in': 'header', 'required': False, 'type': 'string'}, {'name': 'customerID', 'in': 'query', 'description': 'Limit to customerID', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'signature', 'in': 'query', 'description': 'Limit to signature', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'ip', 'in': 'query', 'description': 'Limit to ip/network', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'startTimestamp', 'in': 'query', 'description': 'Limit to events after this timestamp (default is last 24 hours).', 'required': False, 'type': 'str', 'default': '-24hours'}, {'name': 'endTimestamp', 'in': 'query', 'description': 'Limit to events before this timestamp. Defaults to now.', 'required': False, 'type': 'str', 'default': 'now'}, {'name': 'limit', 'in': 'query', 'description': 'Limit results', 'required': False, 'type': 'int', 'default': 25, 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'Offset results', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'associatedCase': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'subject': {'type': 'string'}, 'categoryID': {'type': 'int'}, 'categoryName': {'type': 'string'}, 'service': {'type': 'string'}, 'status': {'type': 'str', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'priority': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}}, 'protocol': {'type': 'string'}, 'flags': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'severity': {'type': 'str', 'readOnly': True, 'enum': ['low', 'medium', 'high', 'critical']}, 'detailedEventIDS': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'id': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}, 'customerInfo': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'shortName': {'type': 'string'}, 'name': {'type': 'string'}}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Dynamic list of properties related to the event', 'additionalProperties': {'type': 'string'}}, 'comments': {'type': 'list', 'position': 0, 'description': 'User, or agent, generated comments for the event', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'associatedCases': {'type': 'list', 'position': 0, 'description': 'Case information for the cases associated to the event.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'subject': {'type': 'string'}, 'categoryID': {'type': 'int'}, 'categoryName': {'type': 'string'}, 'service': {'type': 'string'}, 'status': {'type': 'str', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'priority': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}}}, 'location': {'type': 'dict', 'properties': {'shortName': {'type': 'string'}, 'name': {'type': 'string'}, 'timeZone': {'type': 'string'}, 'id': {'type': 'int'}}}, 'attackInfo': {'type': 'dict', 'properties': {'alarmID': {'type': 'int'}, 'alarmDescription': {'type': 'string'}, 'attackCategoryID': {'type': 'int'}, 'attackCategoryName': {'type': 'string'}, 'signature': {'type': 'string'}}}, 'domain': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'uri': {'type': 'str', 'position': 0, 'description': 'URI of the event'}, 'count': {'type': 'int', 'position': 0, 'description': 'Number of observations for this aggregate'}, 'source': {'type': 'dict', 'properties': {'port': {'type': 'int'}, 'geoLocation': {'type': 'dict', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'locationName': {'type': 'string'}, 'latitude': {'type': 'float'}, 'longitude': {'type': 'float'}}}, 'networkAddress': {'type': 'dict', 'properties': {'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'multicast': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'destination': {'type': 'dict', 'properties': {'port': {'type': 'int'}, 'geoLocation': {'type': 'dict', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'locationName': {'type': 'string'}, 'latitude': {'type': 'float'}, 'longitude': {'type': 'float'}}}, 'networkAddress': {'type': 'dict', 'properties': {'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'multicast': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'timestamp': {'type': 'int', 'position': 0, 'description': 'The time the event happened.'}, 'startTimestamp': {'type': 'int', 'position': 0, 'description': 'First observed event for this aggregate'}, 'endTimestamp': {'type': 'int', 'position': 0, 'description': 'Last observed event for this aggregate'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Last update for the aggregated event'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}
update_events = {'tags': ['events/v1'], 'summary': 'Add event assessments (INTERNAL)', 'description': '', 'operationId': 'updateEvents', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'required': False, 'schema': {'type': 'object', 'required': ['update'], 'properties': {'update': {'type': 'dict', 'properties': {'comment': {'type': 'str', 'position': 0, 'description': 'Add comment for the event'}, 'associateToCase': {'type': 'int', 'position': 0, 'description': 'Specify the case to associate the event to, if 0 is provided means dissociate event from the specified case', 'minimum': 0}, 'associateCases': {'type': 'list', 'position': 0, 'description': 'Add one or more case associations to an event, not required.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'unassociateCases': {'type': 'list', 'position': 0, 'description': "Remove an event's case association for one or multiple cases, not required", 'uniqueItems': True, 'items': {'type': 'int'}}, 'recursiveAnnotation': {'type': 'bool', 'position': 0, 'description': 'If true, apply this event annotation on all subevents of the target events. (default false)', 'default': False}, 'recursiveResult': {'type': 'bool', 'position': 0, 'description': 'If true, also return subevents of the target events in the result. (default false)', 'default': False}, 'handledByAnalyst': {'type': 'bool', 'position': 0, 'description': 'If true, then this will flag the event as manually assessed by an analyst. (default false)', 'default': False}, 'triggers': {'type': 'dict', 'properties': {'slaViolation': {'type': 'bool', 'position': 0, 'description': 'If true, enable trigger to check for customer sla violation. (default false)', 'default': False}, 'internalSlaViolation': {'type': 'bool', 'position': 0, 'description': 'If true, enable trigger to check for internal sla violation (default false)', 'default': False}}}, 'newSeverity': {'type': 'str', 'position': 0, 'description': 'Change severity of the event', 'enum': ['low', 'medium', 'high', 'critical']}, 'flagsToEnable': {'type': 'list', 'position': 0, 'description': 'Define flags to be enabled', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'flagsToDisable': {'type': 'list', 'position': 0, 'description': 'Define flags to be disabled', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}}}, 'eventIdentifiers': {'type': 'list', 'position': 0, 'description': 'Update events specified by full ID (type/timestamp/customerID/eventID)', 'uniqueItems': True, 'items': {'type': 'string'}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'associatedCase': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'subject': {'type': 'string'}, 'categoryID': {'type': 'int'}, 'categoryName': {'type': 'string'}, 'service': {'type': 'string'}, 'status': {'type': 'str', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'priority': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}}, 'protocol': {'type': 'string'}, 'flags': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'severity': {'type': 'str', 'readOnly': True, 'enum': ['low', 'medium', 'high', 'critical']}, 'detailedEventIDS': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'id': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}, 'customerInfo': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'shortName': {'type': 'string'}, 'name': {'type': 'string'}}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Dynamic list of properties related to the event', 'additionalProperties': {'type': 'string'}}, 'comments': {'type': 'list', 'position': 0, 'description': 'User, or agent, generated comments for the event', 'items': {'type': 'dict', 'properties': {'timestamp': {'type': 'int', 'position': 0, 'description': 'When the comment was added.'}, 'user': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'comment': {'type': 'str', 'position': 0, 'description': "The comment's text."}}}}, 'associatedCases': {'type': 'list', 'position': 0, 'description': 'Case information for the cases associated to the event.', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'subject': {'type': 'string'}, 'categoryID': {'type': 'int'}, 'categoryName': {'type': 'string'}, 'service': {'type': 'string'}, 'status': {'type': 'str', 'enum': ['ATTACHMENT_ADDED', 'PENDING_CUSTOMER', 'PENDING_SOC', 'PENDING_VENDOR', 'WORKING_SOC', 'WORKING_CUSTOMER', 'PENDING_CLOSE', 'CLOSED']}, 'priority': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}}}, 'location': {'type': 'dict', 'properties': {'shortName': {'type': 'string'}, 'name': {'type': 'string'}, 'timeZone': {'type': 'string'}, 'id': {'type': 'int'}}}, 'attackInfo': {'type': 'dict', 'properties': {'alarmID': {'type': 'int'}, 'alarmDescription': {'type': 'string'}, 'attackCategoryID': {'type': 'int'}, 'attackCategoryName': {'type': 'string'}, 'signature': {'type': 'string'}}}, 'domain': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}, 'uri': {'type': 'str', 'position': 0, 'description': 'URI of the event'}, 'count': {'type': 'int', 'position': 0, 'description': 'Number of observations for this aggregate'}, 'source': {'type': 'dict', 'properties': {'port': {'type': 'int'}, 'geoLocation': {'type': 'dict', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'locationName': {'type': 'string'}, 'latitude': {'type': 'float'}, 'longitude': {'type': 'float'}}}, 'networkAddress': {'type': 'dict', 'properties': {'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'multicast': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'destination': {'type': 'dict', 'properties': {'port': {'type': 'int'}, 'geoLocation': {'type': 'dict', 'properties': {'countryCode': {'type': 'string'}, 'countryName': {'type': 'string'}, 'locationName': {'type': 'string'}, 'latitude': {'type': 'float'}, 'longitude': {'type': 'float'}}}, 'networkAddress': {'type': 'dict', 'properties': {'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'multicast': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'timestamp': {'type': 'int', 'position': 0, 'description': 'The time the event happened.'}, 'startTimestamp': {'type': 'int', 'position': 0, 'description': 'First observed event for this aggregate'}, 'endTimestamp': {'type': 'int', 'position': 0, 'description': 'Last observed event for this aggregate'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Last update for the aggregated event'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Events not found'}, '412': {'description': 'Validation failed'}}}
update_events_bulk = {'tags': ['events/v1'], 'summary': 'Assess events in bulk mode (INTERNAL)', 'description': 'To be used for bulk assessment of very large amount of events. Returns the number of assessed events.', 'operationId': 'updateEventsBulk', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'required': False, 'schema': {'type': 'object', 'required': ['criteria', 'update'], 'properties': {'criteria': {'type': 'dict', 'properties': {'signature': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourceIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'ip': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationPort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourcePort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'port': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'minSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'maxSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'limit': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Limit results'}, 'offset': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Offset results'}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented)'}, 'customerID': {'type': 'list', 'xml': {'name': 'Customers', 'wrapped': True}, 'position': 0, 'description': 'DEPRECATED! Use customer instead', 'uniqueItems': True, 'items': {'type': 'int', 'xml': {'name': 'CustomerID'}}}, 'skipFutureEvents': {'type': 'bool', 'position': 0, 'description': 'Whether service should generate endTimestamp by current timestamp. (default false)', 'default': False}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Exclude these criteria from the parent criteria.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'eventIdentifier': {'type': 'list', 'position': 0, 'description': 'Search for events specified by full ID (type/timestamp/customerid/eventid).', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'type': 'str', 'timestamp': {'type': 'int', 'xml': {'attribute': True}}, 'customerID': {'type': 'int', 'xml': {'attribute': True}}, 'eventID': {'type': 'str', 'xml': {'attribute': True}}}}}, 'locationID': {'type': 'list', 'position': 0, 'description': 'Search for events having these locations.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'severity': {'type': 'list', 'position': 0, 'description': "Search events with specified severity. Can't be used together with minSeverity/maxSeverity.", 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}, 'customer': {'type': 'list', 'position': 0, 'description': 'Search for events by customer (id or shortname).', 'uniqueItems': True, 'items': {'type': 'string'}}, 'alarmID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these alarms.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'attackCategoryID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these categories.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'geoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source or destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'domain': {'type': 'list', 'position': 0, 'description': 'Search for events having one of these domains. The domains are not validated', 'uniqueItems': True, 'items': {'type': 'string'}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Search for events having these properties (logical AND).', 'additionalProperties': {'type': 'string'}}, 'productionCustomers': {'type': 'bool', 'position': 0, 'description': "If set, apply a customer filter for customers marked as 'not in production'. If true, EXCLUDE customers 'not in production'. If false, REQUIRE customers 'not in production'. Default is unset (no filter on production customers)."}, 'exactMatchProperties': {'type': 'bool', 'position': 0, 'description': 'If set to true, will execute in-memory filtering to only match events that have exact match of properties specified at top level "properties" field of search request. WARN: The count of response would not be reliable, as the filtering is applied in-memory of application server, but the count was done by search engine. (default true)', 'default': True}, 'minCount': {'type': 'int', 'position': 0, 'description': 'Search for events with aggregated count at least this high'}, 'associatedCaseID': {'type': 'list', 'position': 0, 'description': 'Search for events associated to one of these cases, 0 will match events NOT associated with any case', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include source CIDR-networks with wider mask than this'}, 'destinationIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include destination CIDR-networks with wider mask than this'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Allow subcriteria (include or exclude), to refine search arbitrarily', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'signature': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourceIP': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'ip': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationPort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'sourcePort': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'port': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'minSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'maxSeverity': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}, 'limit': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Limit results'}, 'offset': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Offset results'}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented)'}, 'customerID': {'type': 'list', 'xml': {'name': 'Customers', 'wrapped': True}, 'position': 0, 'description': 'DEPRECATED! Use customer instead', 'uniqueItems': True, 'items': {'type': 'int', 'xml': {'name': 'CustomerID'}}}, 'skipFutureEvents': {'type': 'bool', 'position': 0, 'description': 'Whether service should generate endTimestamp by current timestamp. (default false)', 'default': False}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Exclude these criteria from the parent criteria.'}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria).'}, 'eventIdentifier': {'type': 'list', 'position': 0, 'description': 'Search for events specified by full ID (type/timestamp/customerid/eventid).', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'type': 'str', 'timestamp': {'type': 'int', 'xml': {'attribute': True}}, 'customerID': {'type': 'int', 'xml': {'attribute': True}}, 'eventID': {'type': 'str', 'xml': {'attribute': True}}}}}, 'locationID': {'type': 'list', 'position': 0, 'description': 'Search for events having these locations.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'severity': {'type': 'list', 'position': 0, 'description': "Search events with specified severity. Can't be used together with minSeverity/maxSeverity.", 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['low', 'medium', 'high', 'critical']}}, 'customer': {'type': 'list', 'position': 0, 'description': 'Search for events by customer (id or shortname).', 'uniqueItems': True, 'items': {'type': 'string'}}, 'alarmID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these alarms.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'attackCategoryID': {'type': 'list', 'position': 0, 'description': 'Search for events having an attack identifier (signature) mapped to any of these categories.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'destinationGeoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'geoCountry': {'type': 'list', 'position': 0, 'description': 'Search for events where source or destination IP is registered in any of these countries.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'domain': {'type': 'list', 'position': 0, 'description': 'Search for events having one of these domains. The domains are not validated', 'uniqueItems': True, 'items': {'type': 'string'}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Search for events having these properties (logical AND).', 'additionalProperties': {'type': 'string'}}, 'productionCustomers': {'type': 'bool', 'position': 0, 'description': "If set, apply a customer filter for customers marked as 'not in production'. If true, EXCLUDE customers 'not in production'. If false, REQUIRE customers 'not in production'. Default is unset (no filter on production customers)."}, 'exactMatchProperties': {'type': 'bool', 'position': 0, 'description': 'If set to true, will execute in-memory filtering to only match events that have exact match of properties specified at top level "properties" field of search request. WARN: The count of response would not be reliable, as the filtering is applied in-memory of application server, but the count was done by search engine. (default true)', 'default': True}, 'minCount': {'type': 'int', 'position': 0, 'description': 'Search for events with aggregated count at least this high'}, 'associatedCaseID': {'type': 'list', 'position': 0, 'description': 'Search for events associated to one of these cases, 0 will match events NOT associated with any case', 'uniqueItems': True, 'items': {'type': 'int'}}, 'sourceIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include source CIDR-networks with wider mask than this'}, 'destinationIPMinBits': {'type': 'int', 'position': 0, 'description': 'Do not include destination CIDR-networks with wider mask than this'}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Allow subcriteria (include or exclude), to refine search arbitrarily', 'uniqueItems': True, 'items': []}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search, will default to startTimestamp/endTimestamp.This field cannot be used alongside the lastUpdateTime field due to backwards compatibility.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['timestamp', 'startTimestamp', 'endTimestamp', 'all']}}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp'}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp'}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'Order results by these properties (prefix with - to sort descending)', 'items': {'type': 'string'}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Search objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Match only with events marked with a last updated time greater or equal to this.'}, 'indexStartTime': {'type': 'int', 'position': 0, 'description': 'Earliest created time of the indices searched.', 'minimum': 0}, 'indexEndTime': {'type': 'int', 'position': 0, 'description': 'Last created time of the indices searched.', 'minimum': 0}}}}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search, will default to startTimestamp/endTimestamp.This field cannot be used alongside the lastUpdateTime field due to backwards compatibility.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['timestamp', 'startTimestamp', 'endTimestamp', 'all']}}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp'}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp'}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'Order results by these properties (prefix with - to sort descending)', 'items': {'type': 'string'}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Search objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'Match only with events marked with a last updated time greater or equal to this.'}, 'indexStartTime': {'type': 'int', 'position': 0, 'description': 'Earliest created time of the indices searched.', 'minimum': 0}, 'indexEndTime': {'type': 'int', 'position': 0, 'description': 'Last created time of the indices searched.', 'minimum': 0}}}, 'update': {'type': 'dict', 'properties': {'comment': {'type': 'str', 'position': 0, 'description': 'Add comment for the event'}, 'associateToCase': {'type': 'int', 'position': 0, 'description': 'Specify the case to associate the event to, if 0 is provided means dissociate event from the specified case', 'minimum': 0}, 'associateCases': {'type': 'list', 'position': 0, 'description': 'Add one or more case associations to an event, not required.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'unassociateCases': {'type': 'list', 'position': 0, 'description': "Remove an event's case association for one or multiple cases, not required", 'uniqueItems': True, 'items': {'type': 'int'}}, 'recursiveAnnotation': {'type': 'bool', 'position': 0, 'description': 'If true, apply this event annotation on all subevents of the target events. (default false)', 'default': False}, 'recursiveResult': {'type': 'bool', 'position': 0, 'description': 'If true, also return subevents of the target events in the result. (default false)', 'default': False}, 'handledByAnalyst': {'type': 'bool', 'position': 0, 'description': 'If true, then this will flag the event as manually assessed by an analyst. (default false)', 'default': False}, 'triggers': {'type': 'dict', 'properties': {'slaViolation': {'type': 'bool', 'position': 0, 'description': 'If true, enable trigger to check for customer sla violation. (default false)', 'default': False}, 'internalSlaViolation': {'type': 'bool', 'position': 0, 'description': 'If true, enable trigger to check for internal sla violation (default false)', 'default': False}}}, 'newSeverity': {'type': 'str', 'position': 0, 'description': 'Change severity of the event', 'enum': ['low', 'medium', 'high', 'critical']}, 'flagsToEnable': {'type': 'list', 'position': 0, 'description': 'Define flags to be enabled', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}, 'flagsToDisable': {'type': 'list', 'position': 0, 'description': 'Define flags to be disabled', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ESTABLISHED', 'BLOCKED', 'SNAPSHOT', 'FINALIZED', 'SOURCE_IS_CUSTOMERNET', 'DESTINATION_IS_CUSTOMERNET', 'SOURCE_IS_PARTIAL_CUSTOMERNET', 'DESTINATION_IS_PARTIAL_CUSTOMERNET', 'INTRUDER_IS_CUSTOMERNET', 'VICTIM_IS_CUSTOMERNET', 'INTRUDER_IS_PARTIAL_CUSTOMERNET', 'VICTIM_IS_PARTIAL_CUSTOMERNET', 'PARTIALLY_BLOCKED', 'FALSE_POSITIVE', 'NOT_A_THREAT', 'TUNING_CANDIDATE', 'NOTIFIED', 'PARTIALLY_NOTIFIED', 'FOLLOWUP', 'IDENTIFIED_THREAT', 'THREAT_CANDIDATE', 'ACKNOWLEDGED', 'PARTIALLY_ACKNOWLEDGED', 'SEVERITY_ADJUSTED', 'COMMENTED', 'FILTERED', 'CHECKED', 'INCOMPLETE_DETAILS', 'AGGREGATED_BASE_EVENT', 'REMOTE_STORAGE', 'CUSTOM_SOURCE_AGGREGATION', 'CUSTOM_DESTINATION_AGGREGATION', 'CUSTOM_INTRUDER_AGGREGATION', 'CUSTOM_VICTIM_AGGREGATION', 'HAS_DETAILS', 'HAS_PAYLOAD', 'HAS_PCAP', 'ASSOCIATED_TO_CASE_BY_FILTER', 'SEVERITY_INCREASED_BY_FILTER', 'SEVERITY_REDUCED_BY_FILTER', 'CREATED_BY_ANALYSIS_FILTER', 'EXTEND_EVENT_TTL', 'INITIAL_TUNING', 'POST_ANALYSIS', 'PARTIAL_SSL_TERMINATED', 'SSL_TERMINATED', 'AUTO_REPORT', 'MISSING_TIMESTAMP', 'CLOCK_OUT_OF_SYNC', 'DROP_ANALYSIS', 'ESCALATED_BY_REPUTATION', 'HAS_SAMPLE', 'STORE_EVENT', 'STORE_AGGREGATED', 'SOURCE_IS_MANAGED_BY_SOC', 'DESTINATION_IS_MANAGED_BY_SOC', 'HANDLED_BY_ANALYST', 'SLA_VIOLATION', 'PAYLOAD_TRUNCATED', 'HAS_STRING_PAYLOAD']}}}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'type': 'integer', 'format': 'int32'}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Events not found'}, '412': {'description': 'Validation failed'}}}