"""Autogenerated API schema"""
from argus_api import session


get_payload = {'tags': ['events/v1'], 'summary': 'Fetch specified event payload (PUBLIC)', 'description': '', 'operationId': 'getPayload', 'produces': ['application/json'], 'parameters': [{'name': 'type', 'in': 'path', 'description': 'Event type', 'required': True, 'type': 'str', 'enum': ['NIDS', 'AGGR', 'AGGRATTACK']}, {'name': 'timestamp', 'in': 'path', 'description': 'Event timestamp', 'required': True, 'type': 'int', 'minimum': 0}, {'name': 'customerID', 'in': 'path', 'description': 'Customer ID', 'required': True, 'type': 'int', 'minimum': 1}, {'name': 'eventID', 'in': 'path', 'description': 'Unique UUID for the event', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'str', 'position': 0, 'description': 'ID of the event this payload belongs to'}, 'type': 'str', 'payload': {'type': 'str', 'position': 0, 'description': 'Payload string (may be base64-encoded binary, depending on type)'}, 'options': ['ethernet', 'pcap', 'binary', 'string']}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation failed'}}}