"""Autogenerated API schema"""
from argus_api import session


add_location = {'tags': ['development'], 'summary': 'Add new location (DEV)', 'description': '', 'operationId': 'addLocation', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'required': False, 'schema': {'type': 'object', 'properties': {'id': {'type': 'int'}, 'extID': {'type': 'int', 'position': 0, 'description': 'The external ID of the location (0 if not set).'}, 'countryCode': {'type': 'str', 'position': 0, 'description': 'The two-letter code of the country where this location is in.'}, 'locationName': {'type': 'str', 'position': 0, 'description': 'The name of the the location.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this location was last updated.'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['deleted', 'disabled']}}}, 'description': 'Location is a subunit of a region. It contains data about the location and also the region and country it belongs to.'}}], 'responses': {'201': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'extID': {'type': 'int', 'position': 0, 'description': 'The external ID of the location (0 if not set).'}, 'countryCode': {'type': 'str', 'position': 0, 'description': 'The two-letter code of the country where this location is in.'}, 'locationName': {'type': 'str', 'position': 0, 'description': 'The name of the the location.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this location was last updated.'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['deleted', 'disabled']}}}, 'description': 'Location is a subunit of a region. It contains data about the location and also the region and country it belongs to.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}
get_location = {'tags': ['/geoip/v1'], 'summary': 'Lookup location (INTERNAL)', 'description': '', 'operationId': 'getLocation', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'Location ID', 'required': True, 'type': 'int'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'extID': {'type': 'int', 'position': 0, 'description': 'The external ID of the location (0 if not set).'}, 'countryCode': {'type': 'str', 'position': 0, 'description': 'The two-letter code of the country where this location is in.'}, 'locationName': {'type': 'str', 'position': 0, 'description': 'The name of the the location.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this location was last updated.'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['deleted', 'disabled']}}}, 'description': 'Location is a subunit of a region. It contains data about the location and also the region and country it belongs to.'}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation failed'}}}
list_locations = {'tags': ['/geoip/v1'], 'summary': 'List locations (INTERNAL)', 'description': '', 'operationId': 'listLocations', 'produces': ['application/json'], 'parameters': [{'name': 'limit', 'in': 'query', 'description': 'Max number of items to return', 'required': False, 'type': 'int', 'default': 25, 'minimum': 0}, {'name': 'offset', 'in': 'query', 'description': 'The amount of items to skip from the beginning', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}, {'name': 'sortBy', 'in': 'query', 'description': "Fields to sort results by (without a sign is ascending, with '-' sign is descending, supported fields are: id, externalID, countryCode, regionCode)", 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'fromID', 'in': 'query', 'description': 'Only return locations with numeric ID greater than or equal to this value', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'extID': {'type': 'int', 'position': 0, 'description': 'The external ID of the location (0 if not set).'}, 'countryCode': {'type': 'str', 'position': 0, 'description': 'The two-letter code of the country where this location is in.'}, 'locationName': {'type': 'str', 'position': 0, 'description': 'The name of the the location.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this location was last updated.'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['deleted', 'disabled']}}}, 'description': 'Location is a subunit of a region. It contains data about the location and also the region and country it belongs to.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}
search_locations = {'tags': ['/geoip/v1'], 'summary': 'Find locations (INTERNAL)', 'description': '', 'operationId': 'searchLocations', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Search request', 'required': False, 'schema': {'type': 'object', 'properties': {'country': {'type': 'list', 'position': 0, 'description': 'Only return locations from these countries (by country ID or two-letter code).', 'uniqueItems': True, 'items': {'type': 'string'}}, 'extID': {'type': 'list', 'position': 0, 'description': 'Only return locations bound to these external IDs.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'fromID': {'type': 'int', 'position': 0, 'description': 'Only return locations with IDs greater than or equal to this ID.', 'minimum': 0}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'A set of included enumerated flags of the searched locations.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['deleted', 'disabled', 'withoutExtID']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'A set of excluded enumerated flags of the searched locations.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['deleted', 'disabled', 'withoutExtID']}}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'If true, also include locations marked as deleted.'}, 'startTimestamp': {'type': 'int', 'position': 0, 'description': 'Search for locations having lastUpdatedTimestamp greater than or equal to this timestamp.'}, 'endTimestamp': {'type': 'int', 'position': 0, 'description': 'Search for locations having lastUpdatedTimestamp lower than or equal to this timestamp.'}, 'countTimeout': {'type': 'int', 'position': 0, 'description': 'Max wait in seconds for the count query to run. Set the value to -1 to skip counting (count will be returned -1). Set the value to 0 to execute the count query as long as the service allows, max allowed timeout value is 30 (seconds), default value is -1. (default -1)', 'minimum': -1, 'maximum': 30, 'default': -1}, 'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results.', 'minimum': 0}, 'offset': {'type': 'int', 'position': 0, 'description': 'Skip the first (offset) objects. By default, return result from first object.', 'minimum': 0}, 'sortBy': {'type': 'list', 'position': 0, 'description': "Fields to sort results by (without a sign is ascending, with '-' sign is descending).", 'items': {'type': 'str', 'enum': ['id', 'externalID', 'countryCode', 'regionCode', '-id', '-externalID', '-countryCode', '-regionCode']}}}, 'description': 'Request to search for locations'}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'extID': {'type': 'int', 'position': 0, 'description': 'The external ID of the location (0 if not set).'}, 'countryCode': {'type': 'str', 'position': 0, 'description': 'The two-letter code of the country where this location is in.'}, 'locationName': {'type': 'str', 'position': 0, 'description': 'The name of the the location.'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this location was last updated.'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['deleted', 'disabled']}}}, 'description': 'Location is a subunit of a region. It contains data about the location and also the region and country it belongs to.'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}