"""Autogenerated API schema"""
from argus_api import session


add_action = {'tags': ['notifications/v1/rule'], 'summary': 'Add notification action to rule (INTERNAL)', 'description': '', 'operationId': 'addAction', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule to add this action to', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}, {'name': 'index', 'in': 'path', 'description': 'Index to put this action at', 'required': True, 'type': 'int'}, {'in': 'body', 'name': 'body', 'description': 'Action descriptor', 'required': False, 'schema': {'type': 'object', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
add_destination = {'tags': ['notifications/v1/rule'], 'summary': 'Add destination to notification rule (INTERNAL)', 'description': '', 'operationId': 'addDestination', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule to add this destination to', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}, {'in': 'body', 'name': 'body', 'description': 'Destination descriptor', 'required': False, 'schema': {'type': 'object', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'format': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}, 'type': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}, 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}}, 'xml': {'name': 'NotificationDestination'}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
create = {'tags': ['notifications/v1/rule'], 'summary': 'Add notification rule (INTERNAL)', 'description': '', 'operationId': 'create', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Add request', 'required': False, 'schema': {'type': 'object', 'required': ['actions', 'index', 'name'], 'properties': {'matchRule': {'type': 'string'}, 'customerID': {'type': 'int'}, 'setFlags': {'type': 'int'}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'str', 'position': 0, 'description': 'Notification rule name  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'index': {'type': 'int', 'position': 0, 'description': 'index (default 0)', 'minimum': 0, 'default': 0}, 'actions': {'type': 'list', 'position': 0, 'description': 'Actions ', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}, 'maxItems': 2147483647, 'minItems': 1}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
delete_action = {'tags': ['notifications/v1/rule'], 'summary': 'Delete action from notification rule (INTERNAL)', 'description': '', 'operationId': 'deleteAction', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}, {'name': 'index', 'in': 'path', 'description': 'Index of action to delete', 'required': True, 'type': 'int'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
delete_destination = {'tags': ['notifications/v1/rule'], 'summary': 'Delete destination from notification rule (INTERNAL)', 'description': '', 'operationId': 'deleteDestination', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}, {'name': 'index', 'in': 'path', 'description': 'Index of destination to delete', 'required': True, 'type': 'int'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
delete_rule = {'tags': ['notifications/v1/rule'], 'summary': 'Delete notification rule (INTERNAL)', 'description': '', 'operationId': 'deleteRule', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule to delete', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
duplicate_rule = {'tags': ['notifications/v1/rule'], 'summary': 'Duplicate this notification rule (INTERNAL)', 'description': '', 'operationId': 'duplicateRule', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule to duplicate', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
get_rule_by_id = {'tags': ['notifications/v1/rule'], 'summary': 'Fetch notification rule (INTERNAL)', 'description': '', 'operationId': 'getRuleByID', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule to fetch', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
get_rule_by_name = {'tags': ['notifications/v1/rule'], 'summary': 'Fetch notification rule (INTERNAL)', 'description': '', 'operationId': 'getRuleByName', 'produces': ['application/json'], 'parameters': [{'name': 'name', 'in': 'path', 'description': 'Name of rule to fetch', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
list = {'tags': ['notifications/v1/rule'], 'summary': 'List notification rules (INTERNAL)', 'description': '', 'operationId': 'list', 'produces': ['application/json'], 'parameters': [{'name': 'includeDeleted', 'in': 'query', 'description': 'Include deleted rules', 'required': False, 'type': 'bool'}, {'name': 'includeFlags', 'in': 'query', 'description': 'Limit result to rules with these flagbits set', 'required': False, 'type': 'int'}, {'name': 'excludeFlags', 'in': 'query', 'description': 'Limit result to rules with these flagbits unset', 'required': False, 'type': 'int'}, {'name': 'customerID', 'in': 'query', 'description': 'Limit result to rules for these customers', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'limit', 'in': 'query', 'description': 'Limit result', 'required': False, 'type': 'int', 'default': 25}, {'name': 'offset', 'in': 'query', 'description': 'Offset result', 'required': False, 'type': 'int'}, {'name': 'events', 'in': 'query', 'description': 'Limit result to rules for these events', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['CASE_CREATED', 'CASE_UPDATED', 'CASE_CLOSED', 'CASE_REOPENED', 'USER_BLOCKED', 'USER_PASSWORD_RESET', 'REPORT_PUBLISHED', 'SERVICE_NOTIFICATION', 'DOCUMENT_ADDED', 'DOCUMENT_UPDATED', 'DOCUMENT_PUBLISHED', 'DOCUMENT_DISCARDED', 'REPORT_ADDED', 'REPORT_UPDATED', 'REPORT_SUBMITTED_TO_QA', 'REPORT_APPROVED', 'REPORT_PUBLISHED_NEW', 'REPORT_DISCARDED', 'DOCUMENT_COMMENT_ADDED', 'DOCUMENT_LABEL_ADDED', 'DOCUMENT_MOVED', 'DOCUMENT_LOCK_OVERRIDE', 'DOCUMENT_COMMITTED', 'USER_SMS_TOKEN_RETRIEVED', 'USER_API_KEY_ISSUED', 'USER_TOTP_INITIALIZED']}, 'collectionFormat': 'multi'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
list_1 = {'tags': ['notifications/v1/rule'], 'summary': 'Search notification rules (INTERNAL)', 'description': '', 'operationId': 'list_1', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'events': {'type': 'int'}, 'searchString': {'type': 'string'}, 'masterID': {'type': 'int'}, 'encodedEvents': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['CASE_CREATED', 'CASE_UPDATED', 'CASE_CLOSED', 'CASE_REOPENED', 'USER_BLOCKED', 'USER_PASSWORD_RESET', 'REPORT_PUBLISHED', 'SERVICE_NOTIFICATION', 'DOCUMENT_ADDED', 'DOCUMENT_UPDATED', 'DOCUMENT_PUBLISHED', 'DOCUMENT_DISCARDED', 'REPORT_ADDED', 'REPORT_UPDATED', 'REPORT_SUBMITTED_TO_QA', 'REPORT_APPROVED', 'REPORT_PUBLISHED_NEW', 'REPORT_DISCARDED', 'DOCUMENT_COMMENT_ADDED', 'DOCUMENT_LABEL_ADDED', 'DOCUMENT_MOVED', 'DOCUMENT_LOCK_OVERRIDE', 'DOCUMENT_COMMITTED', 'USER_SMS_TOKEN_RETRIEVED', 'USER_API_KEY_ISSUED', 'USER_TOTP_INITIALIZED']}}, 'limit': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Limit results '}, 'offset': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Offset results '}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented) '}, 'includeFlags': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects with these flags set '}, 'excludeFlags': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Exclude objects with these flags set '}, 'customerID': {'type': 'list', 'xml': {'name': 'Customers', 'wrapped': True}, 'position': 0, 'description': 'Limit result to objects belonging to these customers ', 'uniqueItems': True, 'items': {'type': 'int', 'xml': {'name': 'CustomerID'}}}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'Order results by these properties (prefix with - to sort descending) ', 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp '}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp '}}, 'xml': {'name': 'CustomerSearchCriteria'}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
revisions = {'tags': ['notifications/v1/rule'], 'summary': 'List revisions of notification rule (INTERNAL)', 'description': '', 'operationId': 'revisions', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule to fetch', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}, {'name': 'limit', 'in': 'query', 'description': 'Limit result', 'required': False, 'type': 'int', 'default': 25}, {'name': 'offset', 'in': 'query', 'description': 'Offset result', 'required': False, 'type': 'int'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
update_action = {'tags': ['notifications/v1/rule'], 'summary': 'Update notification rule action (INTERNAL)', 'description': '', 'operationId': 'updateAction', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule to update', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}, {'name': 'index', 'in': 'path', 'description': 'Index of action to update', 'required': True, 'type': 'int', 'default': 0}, {'in': 'body', 'name': 'body', 'description': 'Updated action', 'required': False, 'schema': {'type': 'object', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
update_destination = {'tags': ['notifications/v1/rule'], 'summary': 'Update notification rule destination (INTERNAL)', 'description': '', 'operationId': 'updateDestination', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule to update', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}, {'name': 'index', 'in': 'path', 'description': 'Index of destination to update', 'required': True, 'type': 'int'}, {'in': 'body', 'name': 'body', 'description': 'Updated destination', 'required': False, 'schema': {'type': 'object', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'format': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}, 'type': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}, 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}}, 'xml': {'name': 'NotificationDestination'}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
update_rule = {'tags': ['notifications/v1/rule'], 'summary': 'Update notification rule (INTERNAL)', 'description': '', 'operationId': 'updateRule', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of rule to update', 'required': True, 'type': 'int', 'pattern': '[0-9]+'}, {'in': 'body', 'name': 'body', 'description': 'Update request', 'required': False, 'schema': {'type': 'object', 'required': ['index'], 'properties': {'id': {'type': 'int'}, 'name': {'type': 'str', 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'matchRule': {'type': 'string'}, 'setFlags': {'type': 'int'}, 'unsetFlags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'index': {'type': 'int', 'position': 0, 'description': 'index (default null)', 'minimum': 0}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'revision': {'type': 'int'}, 'name': {'type': 'string'}, 'matchRule': {'type': 'string'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'index': {'type': 'int'}, 'flags': {'type': 'int'}, 'actions': {'type': 'list', 'items': {'type': 'dict', 'properties': {'changeMatching': {'type': 'str', 'xml': {'name': 'ChangeMatching'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'changeTypes': {'type': 'list', 'xml': {'name': 'ChangeTypes', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Type'}, 'enum': ['SMS', 'EMAIL']}}, 'changeFormats': {'type': 'list', 'xml': {'name': 'ChangeFormats', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Format'}, 'enum': ['BRIEF', 'FULL']}}, 'changeRoles': {'type': 'list', 'xml': {'name': 'ChangeRoles', 'wrapped': True}, 'uniqueItems': True, 'items': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}}, 'sender': {'type': 'str', 'xml': {'name': 'Sender'}}, 'setFlags': {'type': 'int', 'xml': {'name': 'SetFlags'}}, 'unsetFlags': {'type': 'int', 'xml': {'name': 'UnsetFlags'}}, 'subjectTemplate': {'type': 'dict', 'xml': {'name': 'SubjectTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'bodyTemplate': {'type': 'dict', 'xml': {'name': 'BodyTemplate', 'wrapped': True}, 'description': 'format:html', 'additionalProperties': {'type': 'string'}}, 'smsTemplate': {'type': 'dict', 'xml': {'name': 'SMSTemplate', 'wrapped': True}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}}, 'xml': {'name': 'NotificationRuleAction'}}}, 'additionalDestinations': {'type': 'list', 'items': {'type': 'dict', 'required': ['destination', 'flags', 'format', 'language', 'name', 'role', 'type'], 'properties': {'type': 'str', 'role': {'type': 'str', 'xml': {'name': 'Role'}, 'enum': ['SERVICE_CONTACT', 'CONTACT', 'WATCHER', 'CC', 'OWNER', 'TECH', 'REPORTER', 'CURRENT_USER']}, 'name': {'type': 'str', 'xml': {'name': 'Name'}, 'description': '[\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'destination': {'type': 'str', 'xml': {'name': 'Destination'}}, 'language': {'type': 'str', 'xml': {'name': 'Language'}, 'enum': ['ENGLISH', 'NORWEGIAN']}, 'flags': {'type': 'int', 'xml': {'name': 'Flags'}}, 'options': ['SMS', 'EMAIL']}, 'xml': {'name': 'NotificationDestination'}}}, 'timestamp': {'type': 'int'}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'events': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}