"""Autogenerated API schema"""
from argus_api import session


search_records = {'tags': ['pdns/v3'], 'summary': 'Search against PassiveDNS with criteria and return matching records (PUBLIC)', 'description': 'Search against PassiveDNS with criteria and return matching records. If user exceeds current resource limits, this operation may return status code 402. If that happens, the metaData key millisUntilResourcesAvailable gives a hint as to how long the client needs to wait before attempting again. The results are sorted based on the lastSeenTimestamp in descending order.', 'operationId': 'searchRecords', 'consumes': ['application/json'], 'produces': ['application/json', 'text/csv'], 'parameters': [{'name': 'Accept', 'in': 'header', 'required': False, 'type': 'string'}, {'in': 'body', 'name': 'body', 'required': False, 'schema': {'type': 'object', 'required': ['query'], 'properties': {'query': {'type': 'str', 'position': 0, 'description': 'Lookup query'}, 'aggregateResult': {'type': 'bool', 'position': 0, 'description': 'Whether aggregate results (default true)'}, 'includeAnonymousResults': {'type': 'bool', 'position': 0, 'description': 'Whether include anonymous results (default true)'}, 'rrClass': {'type': 'list', 'position': 0, 'description': 'Lookup with specified record classes', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['in']}}, 'rrType': {'type': 'list', 'position': 0, 'description': 'Lookup with specified record types', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['a', 'aaaa', 'cname', 'dname', 'mx', 'naptr', 'ns', 'ptr', 'rp', 'soa', 'srv', 'txt']}}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Lookup for specified customer IDs', 'uniqueItems': True, 'items': {'type': 'int'}}, 'tlp': {'type': 'list', 'position': 0, 'description': 'Lookup with specified TLPs, public usage only TLP white allowed', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['white', 'green', 'amber', 'red']}}, 'limit': {'type': 'int', 'position': 0, 'description': 'Max number of results to be returned, default unset means default limit 25 will be used, 0 means unlimited'}, 'offset': {'type': 'int', 'position': 0, 'description': 'Number of results to be skipped first, default 0 (default 0)', 'minimum': 0, 'default': 0}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'The field on which to sort the records', 'items': {'type': 'string'}}, 'queryMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Query match strategy, partial must be set to use the wildcard (default exact)', 'enum': ['exact', 'includeSubdomains']}}, 'description': 'Request to search for PDNS records'}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the record was created'}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the record was last updated'}, 'times': {'type': 'int', 'position': 0, 'description': 'The number of times this record has been seen'}, 'tlp': {'type': 'str', 'position': 0, 'description': 'The TLP of this record', 'enum': ['white', 'green', 'amber', 'red']}, 'query': {'type': 'str', 'position': 0, 'description': 'The query section this record represents'}, 'answer': {'type': 'str', 'position': 0, 'description': 'The answer section this record represents'}, 'minTtl': {'type': 'int', 'position': 0, 'description': 'The minimum time-to-live of this record'}, 'maxTtl': {'type': 'int', 'position': 0, 'description': 'The maximum time-to-live of this record'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'The flags for this record', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['partialResult']}}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the record was last seen', 'readOnly': True}, 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when the record was first seen', 'readOnly': True}, 'rrclass': {'type': 'str', 'position': 0, 'description': 'The class of this record', 'readOnly': True, 'enum': ['in']}, 'rrtype': {'type': 'str', 'position': 0, 'description': 'The type of this record', 'readOnly': True, 'enum': ['a', 'aaaa', 'cname', 'dname', 'mx', 'naptr', 'ns', 'ptr', 'rp', 'soa', 'srv', 'txt']}}, 'description': 'Response containing PDNS record information'}}}}}, '401': {'description': 'Authentication failed'}, '402': {'description': 'Resource limit exceeded.'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}