"""Autogenerated API schema"""
from argus_api import session


get_sensor_status_by_status = {'tags': ['sensors/v1'], 'summary': 'Fetch sensor status by ID (INTERNAL)', 'description': '', 'operationId': 'getSensorStatusByStatus', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'ID of sensor to fetch status for', 'required': True, 'type': 'int', 'minimum': 1}], 'deprecated': True, 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'lastEventTimestamp': {'type': 'int', 'position': 0, 'description': 'Timestamp for the last event registered by the sensor.'}, 'lastUpdateTimestamp': {'type': 'int', 'position': 0, 'description': 'Latest timestamp when the sensor status was updated.'}, 'lastAnalyzedTimestamp': {'type': 'int', 'position': 0, 'description': 'Latest timestamp when the analyzer encountered an event for the sensor.'}, 'messageRate': {'type': 'float', 'position': 0, 'description': 'Count per second of events throughput for the sensor (since last report).'}, 'lastAgentHost': {'type': 'str', 'position': 0, 'description': 'Host name/Container name of reporting sensor.'}, 'sensor': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'inScheduledDowntime': {'type': 'boolean'}, 'location': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'shortName': {'type': 'string'}, 'name': {'type': 'string'}, 'timeZone': {'type': 'string'}}}, 'ipaddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'application': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the Application'}, 'name': {'type': 'str', 'position': 0, 'description': "The Application's display name"}, 'shortName': {'type': 'str', 'position': 0, 'description': "The Application's unique short name"}, 'url': {'type': 'str', 'position': 0, 'description': "The Application's URL"}, 'expectedSensorUpdateTime': {'type': 'int', 'position': 0, 'description': 'The expected update time for Sensors using this Application'}, 'department': {'type': 'str', 'position': 0, 'description': "The Application's Department", 'enum': ['none', 'nsa', 'ti', 'log', 'infrastructure']}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': "The Application's reporting severity", 'enum': ['internal', 'low', 'medium', 'high', 'critical']}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'MONITOR_COLLECTION_ONLY']}}}, 'description': "Application SPI model class for a Sensor's Application"}, 'clusterSensor': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'hostname': {'type': 'str', 'position': 0, 'description': "The Sensor's hostname, if available"}, 'application': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the Application'}, 'name': {'type': 'str', 'position': 0, 'description': "The Application's display name"}, 'shortName': {'type': 'str', 'position': 0, 'description': "The Application's unique short name"}, 'url': {'type': 'str', 'position': 0, 'description': "The Application's URL"}, 'expectedSensorUpdateTime': {'type': 'int', 'position': 0, 'description': 'The expected update time for Sensors using this Application'}, 'department': {'type': 'str', 'position': 0, 'description': "The Application's Department", 'enum': ['none', 'nsa', 'ti', 'log', 'infrastructure']}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': "The Application's reporting severity", 'enum': ['internal', 'low', 'medium', 'high', 'critical']}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'MONITOR_COLLECTION_ONLY']}}}, 'description': "Application SPI model class for a Sensor's Application"}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'ipaddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'description': 'A simplified representation of a Sensor containing some basic information'}, 'expectedUpdateTime': {'type': 'int', 'position': 0, 'description': "The Sensor's expected reporting interval"}, 'scheduledDowntimeFromTime': {'type': 'int', 'position': 0, 'description': "The start of the Sensor's scheduled downtime"}, 'scheduledDowntimeUntilTime': {'type': 'int', 'position': 0, 'description': "The end of the Sensor's scheduled downtime"}, 'information': {'type': 'str', 'position': 0, 'description': 'Any information about the Sensor'}, 'hostname': {'type': 'str', 'position': 0, 'description': "The Sensor's IP hostname, if available"}, 'additionalData': {'type': 'str', 'position': 0, 'description': 'Any additional data about the Sensor'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ACTIVE', 'MONITORED', 'DELETED', 'OVERRIDE_UPDATE_TIME', 'MONITORED_ONLY_DAYTIME', 'SHARED_CUSTOMER_DATA', 'ACKNOWLEDGED', 'KEEP_DOWNTIME_ON_UPDATE', 'CLOCK_OUT_OF_SYNC', 'INITIAL_TUNING', 'IN_SCHEDULED_DOWNTIME', 'SSL_TERMINATING', 'CONTRACTUAL']}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was last updated'}, 'lastAcknowledgedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was last acknowledged'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was created'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was deleted'}, 'interfaces': {'type': 'list', 'position': 0, 'description': 'Any active Interfaces attached to the Sensor', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': "The Interface's ID"}, 'interfaceName': {'type': 'str', 'position': 0, 'description': "The Interface's name, must be unique per Sensor"}, 'customerID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated. Use `customerInfo` instead.'}, 'customerInfo': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the customer.'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'Shortname of the customer.'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the domain.'}}, 'description': 'SPI DomainInfo'}}, 'description': 'SPI CustomerInfo'}, 'active': {'type': 'bool', 'position': 0, 'description': 'Whether the Interface is active'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags of the Interface'}, 'sensor': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'hostname': {'type': 'str', 'position': 0, 'description': "The Sensor's hostname, if available"}, 'application': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the Application'}, 'name': {'type': 'str', 'position': 0, 'description': "The Application's display name"}, 'shortName': {'type': 'str', 'position': 0, 'description': "The Application's unique short name"}, 'url': {'type': 'str', 'position': 0, 'description': "The Application's URL"}, 'expectedSensorUpdateTime': {'type': 'int', 'position': 0, 'description': 'The expected update time for Sensors using this Application'}, 'department': {'type': 'str', 'position': 0, 'description': "The Application's Department", 'enum': ['none', 'nsa', 'ti', 'log', 'infrastructure']}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': "The Application's reporting severity", 'enum': ['internal', 'low', 'medium', 'high', 'critical']}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'MONITOR_COLLECTION_ONLY']}}}, 'description': "Application SPI model class for a Sensor's Application"}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'ipaddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'description': 'A simplified representation of a Sensor containing some basic information'}, 'location': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'shortName': {'type': 'string'}, 'name': {'type': 'string'}, 'timeZone': {'type': 'string'}}}}, 'description': 'Interface SPI model class for a Sensor Interface'}}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': 'The reporting severity of the Sensor, especially relevant for its Status', 'enum': ['internal', 'low', 'medium', 'high', 'critical']}}, 'description': 'Sensor SPI model class'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['SENSOR_IS_REPORTING', 'CLUSTER_IS_REPORTING', 'CLOCK_OUT_OF_SYNC']}}}, 'description': "Sensor Status SPI model class for a Sensor's Status"}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
list_sensor_status = {'tags': ['sensors/v1'], 'summary': 'List sensor status (INTERNAL)', 'description': '', 'operationId': 'listSensorStatus', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'customerID', 'in': 'query', 'description': 'Limit search to these customer IDs', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'applicationName', 'in': 'query', 'description': 'Limit search to these applications by name', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'keywords', 'in': 'query', 'description': 'Limit search by sensor hostname or IP address', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'limit', 'in': 'query', 'description': 'Limit results', 'required': False, 'type': 'int', 'default': 25}, {'name': 'offset', 'in': 'query', 'description': 'Offset results', 'required': False, 'type': 'int'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'lastEventTimestamp': {'type': 'int', 'position': 0, 'description': 'Timestamp for the last event registered by the sensor.'}, 'lastUpdateTimestamp': {'type': 'int', 'position': 0, 'description': 'Latest timestamp when the sensor status was updated.'}, 'lastAnalyzedTimestamp': {'type': 'int', 'position': 0, 'description': 'Latest timestamp when the analyzer encountered an event for the sensor.'}, 'messageRate': {'type': 'float', 'position': 0, 'description': 'Count per second of events throughput for the sensor (since last report).'}, 'lastAgentHost': {'type': 'str', 'position': 0, 'description': 'Host name/Container name of reporting sensor.'}, 'sensor': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'inScheduledDowntime': {'type': 'boolean'}, 'location': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'shortName': {'type': 'string'}, 'name': {'type': 'string'}, 'timeZone': {'type': 'string'}}}, 'ipaddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'application': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the Application'}, 'name': {'type': 'str', 'position': 0, 'description': "The Application's display name"}, 'shortName': {'type': 'str', 'position': 0, 'description': "The Application's unique short name"}, 'url': {'type': 'str', 'position': 0, 'description': "The Application's URL"}, 'expectedSensorUpdateTime': {'type': 'int', 'position': 0, 'description': 'The expected update time for Sensors using this Application'}, 'department': {'type': 'str', 'position': 0, 'description': "The Application's Department", 'enum': ['none', 'nsa', 'ti', 'log', 'infrastructure']}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': "The Application's reporting severity", 'enum': ['internal', 'low', 'medium', 'high', 'critical']}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'MONITOR_COLLECTION_ONLY']}}}, 'description': "Application SPI model class for a Sensor's Application"}, 'clusterSensor': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'hostname': {'type': 'str', 'position': 0, 'description': "The Sensor's hostname, if available"}, 'application': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the Application'}, 'name': {'type': 'str', 'position': 0, 'description': "The Application's display name"}, 'shortName': {'type': 'str', 'position': 0, 'description': "The Application's unique short name"}, 'url': {'type': 'str', 'position': 0, 'description': "The Application's URL"}, 'expectedSensorUpdateTime': {'type': 'int', 'position': 0, 'description': 'The expected update time for Sensors using this Application'}, 'department': {'type': 'str', 'position': 0, 'description': "The Application's Department", 'enum': ['none', 'nsa', 'ti', 'log', 'infrastructure']}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': "The Application's reporting severity", 'enum': ['internal', 'low', 'medium', 'high', 'critical']}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'MONITOR_COLLECTION_ONLY']}}}, 'description': "Application SPI model class for a Sensor's Application"}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'ipaddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'description': 'A simplified representation of a Sensor containing some basic information'}, 'expectedUpdateTime': {'type': 'int', 'position': 0, 'description': "The Sensor's expected reporting interval"}, 'scheduledDowntimeFromTime': {'type': 'int', 'position': 0, 'description': "The start of the Sensor's scheduled downtime"}, 'scheduledDowntimeUntilTime': {'type': 'int', 'position': 0, 'description': "The end of the Sensor's scheduled downtime"}, 'information': {'type': 'str', 'position': 0, 'description': 'Any information about the Sensor'}, 'hostname': {'type': 'str', 'position': 0, 'description': "The Sensor's IP hostname, if available"}, 'additionalData': {'type': 'str', 'position': 0, 'description': 'Any additional data about the Sensor'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ACTIVE', 'MONITORED', 'DELETED', 'OVERRIDE_UPDATE_TIME', 'MONITORED_ONLY_DAYTIME', 'SHARED_CUSTOMER_DATA', 'ACKNOWLEDGED', 'KEEP_DOWNTIME_ON_UPDATE', 'CLOCK_OUT_OF_SYNC', 'INITIAL_TUNING', 'IN_SCHEDULED_DOWNTIME', 'SSL_TERMINATING', 'CONTRACTUAL']}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was last updated'}, 'lastAcknowledgedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was last acknowledged'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was created'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was deleted'}, 'interfaces': {'type': 'list', 'position': 0, 'description': 'Any active Interfaces attached to the Sensor', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': "The Interface's ID"}, 'interfaceName': {'type': 'str', 'position': 0, 'description': "The Interface's name, must be unique per Sensor"}, 'customerID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated. Use `customerInfo` instead.'}, 'customerInfo': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the customer.'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'Shortname of the customer.'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the domain.'}}, 'description': 'SPI DomainInfo'}}, 'description': 'SPI CustomerInfo'}, 'active': {'type': 'bool', 'position': 0, 'description': 'Whether the Interface is active'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags of the Interface'}, 'sensor': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'hostname': {'type': 'str', 'position': 0, 'description': "The Sensor's hostname, if available"}, 'application': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the Application'}, 'name': {'type': 'str', 'position': 0, 'description': "The Application's display name"}, 'shortName': {'type': 'str', 'position': 0, 'description': "The Application's unique short name"}, 'url': {'type': 'str', 'position': 0, 'description': "The Application's URL"}, 'expectedSensorUpdateTime': {'type': 'int', 'position': 0, 'description': 'The expected update time for Sensors using this Application'}, 'department': {'type': 'str', 'position': 0, 'description': "The Application's Department", 'enum': ['none', 'nsa', 'ti', 'log', 'infrastructure']}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': "The Application's reporting severity", 'enum': ['internal', 'low', 'medium', 'high', 'critical']}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'MONITOR_COLLECTION_ONLY']}}}, 'description': "Application SPI model class for a Sensor's Application"}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'ipaddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'description': 'A simplified representation of a Sensor containing some basic information'}, 'location': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'shortName': {'type': 'string'}, 'name': {'type': 'string'}, 'timeZone': {'type': 'string'}}}}, 'description': 'Interface SPI model class for a Sensor Interface'}}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': 'The reporting severity of the Sensor, especially relevant for its Status', 'enum': ['internal', 'low', 'medium', 'high', 'critical']}}, 'description': 'Sensor SPI model class'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['SENSOR_IS_REPORTING', 'CLUSTER_IS_REPORTING', 'CLOCK_OUT_OF_SYNC']}}}, 'description': "Sensor Status SPI model class for a Sensor's Status"}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
search_sensor_status = {'tags': ['sensors/v1'], 'summary': 'Search sensor status (INTERNAL)', 'description': '', 'operationId': 'searchSensorStatus', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'limit': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Limit results'}, 'offset': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Offset results'}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented)'}, 'customerID': {'type': 'list', 'xml': {'name': 'Customers', 'wrapped': True}, 'position': 0, 'description': 'Limit result to objects belonging to these customers', 'uniqueItems': True, 'items': {'type': 'int', 'xml': {'name': 'CustomerID'}}}, 'keywords': {'type': 'list', 'position': 0, 'description': 'Search for sensors matching these hostnames or IP-addresses', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'position': 0, 'description': 'Defines how strictly different keywords should be matched (default match any keywords) (default any)', 'enum': ['all', 'any']}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (defaults to all supported fields) (default all)', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['all', 'ipAddress', 'hostname', 'additionalData', 'id']}}, 'customer': {'type': 'list', 'position': 0, 'description': 'Search for sensors belonging to customers identified by their ID or shortname', 'uniqueItems': True, 'items': {'type': 'string'}}, 'excludeReportingSensors': {'type': 'bool', 'position': 0, 'description': 'DEPRECATED: Use exclude flags'}, 'excludeSensorsInScheduledDowntime': {'type': 'bool', 'position': 0, 'description': 'DEPRECATED: Use exclude flags'}, 'excludeSensorsInReportingCluster': {'type': 'bool', 'position': 0, 'description': 'DEPRECATED: Use exclude flags'}, 'lastAgentHost': {'type': 'str', 'position': 0, 'description': 'Include sensors where lastAgentHost matches this string (entire/partial)'}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp'}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp'}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'Order results by these properties (prefix with - to sort descending)', 'items': {'type': 'string'}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Search objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ACTIVE', 'MONITORED', 'DELETED', 'OVERRIDE_UPDATE_TIME', 'MONITORED_ONLY_DAYTIME', 'SHARED_CUSTOMER_DATA', 'ACKNOWLEDGED', 'KEEP_DOWNTIME_ON_UPDATE', 'CLOCK_OUT_OF_SYNC', 'INITIAL_TUNING', 'IN_SCHEDULED_DOWNTIME', 'SENSOR_IS_REPORTING', 'CLUSTER_IS_REPORTING', 'SSL_TERMINATING']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects with these flags set', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ACTIVE', 'MONITORED', 'DELETED', 'OVERRIDE_UPDATE_TIME', 'MONITORED_ONLY_DAYTIME', 'SHARED_CUSTOMER_DATA', 'ACKNOWLEDGED', 'KEEP_DOWNTIME_ON_UPDATE', 'CLOCK_OUT_OF_SYNC', 'INITIAL_TUNING', 'IN_SCHEDULED_DOWNTIME', 'SENSOR_IS_REPORTING', 'CLUSTER_IS_REPORTING', 'SSL_TERMINATING']}}, 'sensorID': {'type': 'list', 'position': 0, 'description': 'Search for specific sensors by ID', 'uniqueItems': True, 'items': {'type': 'int'}}, 'locationName': {'type': 'list', 'position': 0, 'description': 'Search for sensors bound to any of these locations', 'uniqueItems': True, 'items': {'type': 'string'}}, 'applicationName': {'type': 'list', 'position': 0, 'description': 'Search for sensors by application type', 'uniqueItems': True, 'items': {'type': 'string'}}}, 'description': 'Search criteria for Sensor Statuses'}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'properties': {'lastEventTimestamp': {'type': 'int', 'position': 0, 'description': 'Timestamp for the last event registered by the sensor.'}, 'lastUpdateTimestamp': {'type': 'int', 'position': 0, 'description': 'Latest timestamp when the sensor status was updated.'}, 'lastAnalyzedTimestamp': {'type': 'int', 'position': 0, 'description': 'Latest timestamp when the analyzer encountered an event for the sensor.'}, 'messageRate': {'type': 'float', 'position': 0, 'description': 'Count per second of events throughput for the sensor (since last report).'}, 'lastAgentHost': {'type': 'str', 'position': 0, 'description': 'Host name/Container name of reporting sensor.'}, 'sensor': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'inScheduledDowntime': {'type': 'boolean'}, 'location': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'shortName': {'type': 'string'}, 'name': {'type': 'string'}, 'timeZone': {'type': 'string'}}}, 'ipaddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'application': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the Application'}, 'name': {'type': 'str', 'position': 0, 'description': "The Application's display name"}, 'shortName': {'type': 'str', 'position': 0, 'description': "The Application's unique short name"}, 'url': {'type': 'str', 'position': 0, 'description': "The Application's URL"}, 'expectedSensorUpdateTime': {'type': 'int', 'position': 0, 'description': 'The expected update time for Sensors using this Application'}, 'department': {'type': 'str', 'position': 0, 'description': "The Application's Department", 'enum': ['none', 'nsa', 'ti', 'log', 'infrastructure']}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': "The Application's reporting severity", 'enum': ['internal', 'low', 'medium', 'high', 'critical']}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'MONITOR_COLLECTION_ONLY']}}}, 'description': "Application SPI model class for a Sensor's Application"}, 'clusterSensor': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'hostname': {'type': 'str', 'position': 0, 'description': "The Sensor's hostname, if available"}, 'application': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the Application'}, 'name': {'type': 'str', 'position': 0, 'description': "The Application's display name"}, 'shortName': {'type': 'str', 'position': 0, 'description': "The Application's unique short name"}, 'url': {'type': 'str', 'position': 0, 'description': "The Application's URL"}, 'expectedSensorUpdateTime': {'type': 'int', 'position': 0, 'description': 'The expected update time for Sensors using this Application'}, 'department': {'type': 'str', 'position': 0, 'description': "The Application's Department", 'enum': ['none', 'nsa', 'ti', 'log', 'infrastructure']}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': "The Application's reporting severity", 'enum': ['internal', 'low', 'medium', 'high', 'critical']}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'MONITOR_COLLECTION_ONLY']}}}, 'description': "Application SPI model class for a Sensor's Application"}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'ipaddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'description': 'A simplified representation of a Sensor containing some basic information'}, 'expectedUpdateTime': {'type': 'int', 'position': 0, 'description': "The Sensor's expected reporting interval"}, 'scheduledDowntimeFromTime': {'type': 'int', 'position': 0, 'description': "The start of the Sensor's scheduled downtime"}, 'scheduledDowntimeUntilTime': {'type': 'int', 'position': 0, 'description': "The end of the Sensor's scheduled downtime"}, 'information': {'type': 'str', 'position': 0, 'description': 'Any information about the Sensor'}, 'hostname': {'type': 'str', 'position': 0, 'description': "The Sensor's IP hostname, if available"}, 'additionalData': {'type': 'str', 'position': 0, 'description': 'Any additional data about the Sensor'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['ACTIVE', 'MONITORED', 'DELETED', 'OVERRIDE_UPDATE_TIME', 'MONITORED_ONLY_DAYTIME', 'SHARED_CUSTOMER_DATA', 'ACKNOWLEDGED', 'KEEP_DOWNTIME_ON_UPDATE', 'CLOCK_OUT_OF_SYNC', 'INITIAL_TUNING', 'IN_SCHEDULED_DOWNTIME', 'SSL_TERMINATING', 'CONTRACTUAL']}}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was last updated'}, 'lastAcknowledgedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was last acknowledged'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was created'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}, 'type': 'str', 'options': ['user', 'group']}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'When the Sensor was deleted'}, 'interfaces': {'type': 'list', 'position': 0, 'description': 'Any active Interfaces attached to the Sensor', 'items': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': "The Interface's ID"}, 'interfaceName': {'type': 'str', 'position': 0, 'description': "The Interface's name, must be unique per Sensor"}, 'customerID': {'type': 'int', 'position': 0, 'description': 'DEPRECATED: Deprecated. Use `customerInfo` instead.'}, 'customerInfo': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the customer.'}, 'shortName': {'type': 'str', 'position': 0, 'description': 'Shortname of the customer.'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the response object.'}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the domain.'}}, 'description': 'SPI DomainInfo'}}, 'description': 'SPI CustomerInfo'}, 'active': {'type': 'bool', 'position': 0, 'description': 'Whether the Interface is active'}, 'flags': {'type': 'int', 'position': 0, 'description': 'Flags of the Interface'}, 'sensor': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'hostname': {'type': 'str', 'position': 0, 'description': "The Sensor's hostname, if available"}, 'application': {'type': 'dict', 'properties': {'id': {'type': 'int', 'position': 0, 'description': 'ID of the Application'}, 'name': {'type': 'str', 'position': 0, 'description': "The Application's display name"}, 'shortName': {'type': 'str', 'position': 0, 'description': "The Application's unique short name"}, 'url': {'type': 'str', 'position': 0, 'description': "The Application's URL"}, 'expectedSensorUpdateTime': {'type': 'int', 'position': 0, 'description': 'The expected update time for Sensors using this Application'}, 'department': {'type': 'str', 'position': 0, 'description': "The Application's Department", 'enum': ['none', 'nsa', 'ti', 'log', 'infrastructure']}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': "The Application's reporting severity", 'enum': ['internal', 'low', 'medium', 'high', 'critical']}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'MONITOR_COLLECTION_ONLY']}}}, 'description': "Application SPI model class for a Sensor's Application"}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'ipaddress': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'description': 'A simplified representation of a Sensor containing some basic information'}, 'location': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'shortName': {'type': 'string'}, 'name': {'type': 'string'}, 'timeZone': {'type': 'string'}}}}, 'description': 'Interface SPI model class for a Sensor Interface'}}, 'reportingSeverity': {'type': 'str', 'position': 0, 'description': 'The reporting severity of the Sensor, especially relevant for its Status', 'enum': ['internal', 'low', 'medium', 'high', 'critical']}}, 'description': 'Sensor SPI model class'}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['SENSOR_IS_REPORTING', 'CLUSTER_IS_REPORTING', 'CLOCK_OUT_OF_SYNC']}}}, 'description': "Sensor Status SPI model class for a Sensor's Status"}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
#: "list_sensors" is an alias for "list_sensor_status"
list_sensors = list_sensor_status
#: "find_sensors" is an alias for "search_sensor_status"
find_sensors = search_sensor_status